<?php
// $Id: pnadminapi.php,v 1.2 2003/03/24 07:37:53 bravecobra Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  ContentExpress administration API
// ----------------------------------------------------------------------

$ModName = basename( dirname( __FILE__ ));
include_once( "modules/$ModName/pnclass/CommonExpress.php" );
include_once( "modules/$ModName/pneditor/pnCEHTML.php" );
include_once( "modules/$ModName/pnclass/Category.php" );
include_once( "modules/$ModName/pnclass/ContentExpress.php" );
include_once( "modules/$ModName/pnclass/MediaExpress.php" );
include_once( "modules/$ModName/pnclass/MenuExpress.php" );

/**
 * create a new ContentExpress item
 * @param $args['title'] title of the content item
 * @param $args['text'] text of the content item
 * @param $args['parent_id'] parent of the content item
 * @param $args['layout_id'] layout of the content item
 * @param $args['menu_id'] menu id associated with the content item
 * @param $args['upld_media'] media temp. filename of the content item
 * @param $args['upld_media_name'] media filename of the content item
 * @param $args['upld_media_type'] media file type of the content item
 * @param $args['upld_media_width'] media width of the content item
 * @param $args['upld_media_height'] media height of the content item
 * @param $args['upld_media_size'] media file size of the content item
 * @param $args['language'] language of the content item
 * @param $args['weight'] weight of the content item
 * @param $args['active'] status of the content item
 * @returns int
 * @return ContentExpress content item ID on success, false on failure
 */
function ContentExpress_adminapi_createcontent($args)
{
    $content = new ContentExpress();
    return $content->api_create( $args );
}

/**
 * delete a ContentExpress content item
 * @param $args['ceid'] ID of the content item
 * @returns bool
 * @return true on success, false on failure
 */
function ContentExpress_adminapi_deletecontent($args)
{
    $content = new ContentExpress();
    return $content->api_delete( $args );
}

/**
 * update a ContentExpress content item
 * @param $args['ceid'] the ID of the content item
 * @param $args['title'] the new title of the content item
 * @param $args['text'] the new text of the content item
 * @param $args['parent_id'] the new parent_id of the content item
 * @param $args['layout_id'] the new layout_id of the content item
 * @param $args['menu_id'] the new menu_id of the content item
 * @param $args['language'] the new language of the content item
 * @param $args['weight'] the new weight of the content item
 * @param $args['active'] the new status of the content item
 */
function ContentExpress_adminapi_updatecontent($args)
{
    $content = new ContentExpress();
    return $content->api_update( $args );
}

/**
 * quick update a ContentExpress content item
 * @param $args['ceid'] the ID of the content item
 * @param $args['pid'] the previous/parent id of the content item
 * @param $args['task'] the task to be performed on the content item
 */
function ContentExpress_adminapi_qupdcontent($args)
{
    $content = new ContentExpress();
    return $content->api_qupdate( $args );
}

/**
 * create a new ContentExpress category
 * @param $args['title'] title of the category item
 * @param $args['text'] text of the category item
 * @param $args['parent_id'] parent of the category item
 * @param $args['language'] language of the category item
 * @param $args['weight'] weight of the category item
 * @param $args['active'] status of the category item
 * @returns int
 * @return ContentExpress category item ID on success, false on failure
 */
function ContentExpress_adminapi_createcategory($args)
{
    $category = new Category();
    return $category->api_create( $args );
}

/**
 * delete a ContentExpress category item
 * @param $args['cecatid'] ID of the category item
 * @returns bool
 * @return true on success, false on failure
 */
function ContentExpress_adminapi_deletecategory($args)
{
    $category = new Category();
    return $category->api_delete( $args );
}

/**
 * update a ContentExpress category item
 * @param $args['cecatid'] the ID of the category item
 * @param $args['title'] the new title of the category item
 * @param $args['parent_id'] the new parent_id of the category item
 * @param $args['language'] the new language of the category item
 * @param $args['weight'] the new weight of the category item
 * @param $args['active'] the new status of the category item
 */
function ContentExpress_adminapi_updatecategory($args)
{
    $category = new Category();
    return $category->api_update( $args );
}

/**
 * quick update a ContentExpress category item
 * @param $args['cecatid'] the ID of the category item
 * @param $args['pid'] the previous/parent id of the category item
 * @param $args['task'] the task to be performed on the category item
 */
function ContentExpress_adminapi_qupdcategory($args)
{
    $category = new Category();
    return $category->api_qupdate( $args );
}

/**
 * create a new MenuExpress item
 * @param $args['title'] title of the menu item
 * @param $args['anchor'] url of the menu item
 * @param $args['parent_id'] parent of the menu item
 * @param $args['language'] language of the menu item
 * @param $args['weight'] weight of the menu item
 * @param $args['active'] status of the menu item
 * @returns int
 * @return ContentExpress menu item ID on success, false on failure
 */
function ContentExpress_adminapi_createmenu($args)
{
    $menu = new MenuExpress();
    return $menu->api_create( $args );
}

/**
 * delete a MenuExpress menu item
 * @param $args['mid'] ID of the menu item
 * @returns bool
 * @return true on success, false on failure
 */
function ContentExpress_adminapi_deletemenu($args)
{
    $menu = new MenuExpress();
    return $menu->api_delete( $args );
}

/**
 * update a MenuExpress menu item
 * @param $args['mid'] the ID of the menu item
 * @param $args['title'] the new title of the menu item
 * @param $args['anchor'] the new anchor of the menu item
 * @param $args['parent_id'] the new parent_id of the menu item
 * @param $args['language'] the new language of the menu item
 * @param $args['weight'] the new weight of the menu item
 * @param $args['active'] the new status of the menu item
 */
function ContentExpress_adminapi_updatemenu($args)
{
    $menu = new MenuExpress();
    return $menu->api_update( $args );
}

/**
 * quick update a MenuExpress menu item
 * @param $args['mid'] the ID of the menu item
 * @param $args['pid'] the previous/parent id of the menu item
 * @param $args['task'] the task to be performed on the menu item
 */
function ContentExpress_adminapi_qupdmenu($args)
{
    $menu = new MenuExpress();
    return $menu->api_qupdate( $args );
}

/**
 * update a ContentExpress media repository
 * @param $args['media_url'] media to be removed
 * @param $args['upld_media'] temp. media file name from media upload
 * @param $args['upld_media_name'] the new media file name
 * @param $args['upld_media_size'] the new media file size
 * @param $args['upld_media_type'] the new media file type
 */
function ContentExpress_adminapi_updatemedia($args)
{
    $media = new MediaExpress();
    return $media->api_updmedia( $args );
}

?>
