<?php

// $Id: Category.php,v 1.9 2003/05/26 14:24:18 linuxwarrior Exp $
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: Category
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  Category class
// ----------------------------------------------------------------------

$ModName = basename( dirname( dirname( __FILE__ )));

class Category
{
    // Called by pntables.php
    function pntables( &$pntable )
    {
        // Get the name for the content category table.  This is not necessary
        // but helps in the following statements and keeps them readable
        $categories = pnConfigGetVar('prefix') . '_ce_categories';
    
        // Set the table name
        $pntable['ce_categories'] = $categories;
    
        // Set the column names.  Note that the array has been formatted
        // on-screen to be very easy to read by a user.
        $pntable['ce_categories_column'] = array(
            'id'           => $categories . '.mc_id',
            'parent_id'    => $categories . '.mc_parent_id',
            'title'        => $categories . '.mc_title',
            'language'     => $categories . '.mc_language');
    }

    // Called by pninit.php
    function init( $dbconn )
    {
        $pntable = pnDBGetTables();

        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Create the table - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating out
        // the SQL statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "CREATE TABLE $categories_table ( ";
        $sql .= "$categories_column[id] int(11) NOT NULL auto_increment, ";
        $sql .= "$categories_column[parent_id] int(11) NOT NULL default '-1', ";
        $sql .= "$categories_column[title] text NOT NULL, ";
        $sql .= "$categories_column[language] varchar(30) NOT NULL, ";
        $sql .= "PRIMARY KEY (mc_id))";
        $dbconn->Execute($sql);

        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $categories_table");
            return false;
        }

        $sql  = "INSERT INTO $categories_table ( ";
        $sql .= "$categories_column[id], ";
        $sql .= "$categories_column[parent_id], ";
        $sql .= "$categories_column[title], ";
        $sql .= "$categories_column[language] ";
        $sql .= ") VALUES ( ";
        $sql .= "'1', ";
        $sql .= "'-1', ";
        $sql .= "'No Category', ";
        $sql .= "'x_all' );";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $statuses_table");
            return false;
        }

        return true;
    }

    // Called by pninit.php
    function upgrade($oldversion)
    {
	list($dbconn) = pnDBGetConn();
	$pntable = pnDBGetTables();

        // Update successful
        switch($oldversion) {
            case "1.0":
            case "1.1":
            case "1.1b":
            case "1.1c":
            case "1.1d":
            case "1.2":
            case "1.2.1":
            case "1.2.2":
            case "1.2.3":
            case "1.2.4":
            case "1.2.4.1":
            case "1.2.4.2":
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $categories_table = $pntable['ce_categories'];
                $categories_column = &$pntable['ce_categories_column'];
    
                // Create the table - the formatting here is not mandatory, but it does
                // make the SQL statement relatively easy to read.  Also, separating out
                // the SQL statement from the Execute() command allows for simpler
                // debug operation if it is ever needed
                $sql  = "CREATE TABLE $categories_table ( ";
                $sql .= "$categories_column[id] int(11) NOT NULL auto_increment, ";
                $sql .= "$categories_column[parent_id] int(11) NOT NULL default '-1', ";
                $sql .= "$categories_column[title] text NOT NULL, ";
                $sql .= "$categories_column[language] varchar(30) NOT NULL, ";
                $sql .= "PRIMARY KEY (mc_id))";
                $dbconn->Execute($sql);
            
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $categories_table");
                    return false;
                }

                $sql  = "INSERT INTO $categories_table ( ";
                $sql .= "$categories_column[id], ";
                $sql .= "$categories_column[parent_id], ";
                $sql .= "$categories_column[title], ";
                $sql .= "$categories_column[language] ";
                $sql .= ") VALUES ( ";
                $sql .= "'1', ";
                $sql .= "'-1', ";
                $sql .= "'No Category', ";
                $sql .= "'x_all' );";
                $dbconn->Execute($sql);
            
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _INSERTTABLEFAILED ." - $categories_table");
                    return false;
                }

            case "1.2.4.3":
            case "1.2.4.4":
            case "1.2.4.5":
            case "1.2.4.6":
            case "1.2.4.7":
            case "1.2.4.8":
            case "1.2.4.9":
            case "1.2.4.10":
            case "1.2.5.1":
            case "1.2.5.2":
            case "1.2.5.3":
            case "1.2.5.4":
                break;
        }
        return true;
    }

    // Called by pninit.php
    function remove()
    {
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // Drop the table - for such a simple command the advantages of separating
        // out the SQL statement from the Execute() command are minimal, but as
        // this has been done elsewhere it makes sense to stick to a single method
        $sql = "DROP TABLE $pntable[ce_categories]";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Report failed deletion attempt
            pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[ce_categories]");
            return false;
        }
    
        return true;
    }

    // Will be called by pnversion.php
    function version( &$modversion )
    {
        $modversion['name'] = 'CommonExpress';
        $modversion['version'] = '1.2.6.0';
        $modversion['description'] = 'Common Library for XExpress modules';
        $modversion['credits'] = 'docs/credits.txt';
        $modversion['help'] = 'docs/help.txt';
        $modversion['changelog'] = 'docs/changelog.txt';
        $modversion['license'] = 'docs/license.txt';
        $modversion['official'] = 0;
        $modversion['author'] = 'Chester Chee';
        $modversion['contact'] = 'http://pn.arising.net/ce/';
        $modversion['admin'] = 1;
        $modversion['securityschema'] = array('ContentExpress::Category' => 'Category title::Category ID');
    }

    // Administrative API helper methods
    // API create category
    function api_create($args)
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($parent_id)) || (!isset($language)) || (!isset($title))) {
            pnSessionSetVar('errormsg', _MODARGSERROR."$parent_id, $language, $title");
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "::", ACCESS_ADD)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Verify the title is not empty
        if( trim( $title ) == "" ) {
            pnSessionSetVar('errormsg', _MENUCONTENTBADCATEGORYNAME);
            return false;
        }

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Get next ID in table - this is required prior to any insert that
        // uses a unique ID, and ensures that the ID generation is carried
        // out in a database-portable fashion
        $nextId = $dbconn->GenId($categories_table);
    
        // Add content item - the formatting here is not mandatory, but it does make
        // the SQL statement relatively easy to read.  Also, separating out
        // the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "INSERT INTO $categories_table ( ";
        $sql .= "$categories_column[id], ";
        $sql .= "$categories_column[parent_id], ";
        $sql .= "$categories_column[language], ";
        $sql .= "$categories_column[title] ";
        $sql .= ") VALUES ( ";
        $sql .= "  $nextId, ";
        $sql .= "" . pnVarPrepForStore($parent_id) . ", ";
        $sql .= "'" . pnVarPrepForStore($language) . "', ";
        $sql .= "'" . pnVarPrepForStore($title) . "');";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATEFAILED);
            return false;
        }
    
        // Get the ID of the item that we inserted.  It is possible, although
        // very unlikely, that this is different from $nextId as obtained
        // above, but it is better to be safe than sorry in this situation
        $id = $dbconn->PO_Insert_ID($categories_table, $categories_column['id']);
    
        // Let any hooks know that we have created a new item.  As this is a
        // create hook we're passing 'ceid' as the extra info, which is the
        // argument that all of the other functions use to reference this
        // item
        pnModCallHooks('item', 'create', $id, 'cecatid');
    
        // Return the id of the newly created item to the calling process
        return $id;
    }

    // Administrative API helper methods
    // API delete category
    function api_delete( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if (!isset($cecatid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_category',
                array('cecatid' => $cecatid));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$item[title]::$cecatid", ACCESS_DELETE)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Need to check to see if this category item has any children, if so, need to
        // shift them one level up so it won't become orphanage.
        $sql  = "UPDATE $categories_table ";
        $sql .= "SET $categories_column[parent_id] = " . pnVarPrepForStore($item['parent_id']) . " ";
        $sql .= "WHERE $categories_column[parent_id] = " . pnVarPrepForStore($cecatid);
        $dbconn->Execute($sql);
    
        // Choose to ignore any error since it is possible there is no sub-category for the
        // specified category
    
        // Need to check to see if there is any content item under this category,if so,
        // need to shift them to Unfiled categories
        $sql  = "UPDATE $contentitems_table ";
        $sql .= "SET $contentitems_column[catid] = 1 ";
        $sql .= "WHERE $contentitems_column[catid] = " . pnVarPrepForStore($cecatid);
        $dbconn->Execute($sql);
    
        // Choose to ignore any error since it is possible there is no content page for the
        // specified category

        // Delete the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "DELETE FROM $categories_table ";
        $sql .= "WHERE $categories_column[id] = " . pnVarPrepForStore($cecatid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _DELETEFAILED);
            return false;
        }
    
        // Let any hooks know that we have deleted an item.  As this is a
        // delete hook we're not passing any extra info
        pnModCallHooks('item', 'delete', $cecatid, '');
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    // Administrative API helper methods
    // API update
    function api_update( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($cecatid)) || (!isset($parent_id)) ||
            (!isset($language)) || (!isset($title))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_category',
                array('cecatid' => $cecatid ));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
    
        // Note that at this stage we have two sets of item information, the
        // pre-modification and the post-modification.  We need to check against
        // both of these to ensure that whoever is doing the modification has
        // suitable permissions to edit the item otherwise people can potentially
        // edit areas to which they do not have suitable access
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$item[title]::$cecatid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Update the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "UPDATE $categories_table ";
        $sql .= "SET $categories_column[parent_id] = " . pnVarPrepForStore($parent_id) . ", ";
        $sql .= "    $categories_column[language] = '" . pnVarPrepForStore($language) . "', ";
        $sql .= "    $categories_column[title] = '" . pnVarPrepForStore($title) . "' ";
        $sql .= "WHERE $categories_column[id] = " . pnVarPrepForStore($cecatid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }
    
        // Let any hooks know that we have created a new item.  As this is a
        // create hook we're passing 'ceid' as the extra info, which is the
        // argument that all of the other functions use to reference this
        // item
        pnModCallHooks('item', 'transform', $cecatid, 'cecatid');
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    // Administrative API helper methods
    // API quick update
    function api_qupdate( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($cecatid)) || (!isset($task))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if( empty( $pid )) { $pid = -1; }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_category',
                array('cecatid' => $cecatid ));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        $pitem = false;
        if( $pid > 0 ) {
            $pitem = pnModAPIFunc('ContentExpress',
                                  'user',
                                  'get_category',
                                  array('cecatid' => $pid ));
            if( $pitem == false ) {
                pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
                return false;
            }
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
    
        // Note that at this stage we have two sets of item information, the
        // pre-modification and the post-modification.  We need to check against
        // both of these to ensure that whoever is doing the modification has
        // suitable permissions to edit the item otherwise people can potentially
        // edit areas to which they do not have suitable access
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$item[title]::$cecatid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Update the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql = "";
        if( $task == 'left' ) {
            $sql  = "UPDATE $categories_table ";
            $sql .= "SET $categories_column[parent_id] = '" . pnVarPrepForStore($pitem['parent_id']) . "' ";
            $sql .= "WHERE $categories_column[id] = " . pnVarPrepForStore($cecatid);
        }
        else if( $task == 'right' ) {
            $sql  = "UPDATE $categories_table ";
            $sql .= "SET $categories_column[parent_id] = '" . pnVarPrepForStore($pid) . "' ";
            $sql .= "WHERE $categories_column[id] = " . pnVarPrepForStore($cecatid);
        }
        else {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    function admin_new()
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Category', '::', ACCESS_ADD)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Add content to output - it helps if all of the module pages have a standard
        // content at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->Text($this->admin_view( array('action' => "newcategory") ));
        $output->Linebreak();
        $output->Text($this->admin_build_form( _MENUCONTENTADDCAT, _MENUCONTENTSAVECAT));

        $output->SetInputMode(_PNH_PARSEINPUT);

        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableStart( "", "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();
   
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_create( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($parent_id, $language, $title) = pnVarCleanFromInput('parent_id', 'language', 'title');
    
        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcategory'));
            return true;
        }
    
        if( strlen( trim( $title )) == 0 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGTITLE);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcategory'));
            return true;
        }
        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the creation of the new item is
        // done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array
        $id = pnModAPIFunc('ContentExpress',
                           'admin',
                           'createcategory',
                           array(
                                 'parent_id' => $parent_id,
                                 'language' => $language,
                                 'title' => $title));
    
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if ($id != false) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCATCREATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newcategory'));
    
        // Return
        return true;
    }

    function admin_view($args)
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        if (!pnSecAuthAction(0, 'ContentExpress::Category', '::', ACCESS_ADMIN)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        
        list($cecatid) = pnVarCleanFromInput('cecatid');
        extract($args);
        
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_categories');
    
        if ($items == false) {
            // Since there will be time when there is nothing in the table, so
            // it won't make sense to say no such item here.
            //$output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }

        $output->SetOutputMode(_PNH_RETURNOUTPUT);

        // Get the content info
        $curr_cecatid = $cecatid;    
    
        // Built the category tree
        $no_category = "";
        $categories = array();
        foreach($items as $item) {
            $id = $item['id'];
            $parent_id = $item['parent_id'];
            $title = $item['title'];
            $category = "";
    
            $category = $output->Text( $title );

            if( $id != 1 ) {
                $categories[($id+0)] = array( 'id'      => ($id+0),
                                              'title'   => $category,
                                              'parent'  => ($parent_id+0),
                                              'child'   => array() );
            } else {
                $no_category = array( 'id'      => ($id+0),
                                      'title'   => $category,
                                      'parent'  => ($parent_id+0),
                                      'child'   => array() );
            }
        }
    
        $orphans = array();
        foreach( $categories as $id => $category ) {
            $parent_id = $category['parent'];
            if( $parent_id > 0 && !empty( $categories[$parent_id] )) {
                // locates the parent and then updates its child list
                array_push( $categories[$parent_id]['child'], $id );
            } else {
                array_push( $orphans, $id );
            }
        }

        // Expand all sibling categories items along the category path 
        $prev_id = 1;
        $categories2 = array();
        $categories2[1] = $no_category;

        CommonExpress_build_dynitems_tree( $categories, $categories2, $curr_cecatid );

        foreach( $categories2 as $id => $category ) {

            $actions = array();
            $parent_id = $category['parent'];
            if( $parent_id != -1 ) {
                $children = $categories2[$parent_id]['child'];
            } else {
                $children = $orphans;
            }
            $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "editcategory",
                                                 array( 'cecatid' => $id )),
                                       _MENUCONTENTEDIT );
            if( $id != 1 ) {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "delcategory",
                                                     array( 'cecatid' => $id )),
                                           _MENUCONTENTDELETE );
            } else {
                $actions[] = $output->Text( _MENUCONTENTDELETE );
            }
    
            // only condition the category item can't move "left" is if its parent id is -1 (i.e. Top Level)
            if( $parent_id != -1 ) {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcategory",
                                                     array( 'cecatid' => $id,
                                                            'pid' => $parent_id,
                                                            'task' => 'left',
                                                            'authid' => pnSecGenAuthKey() )),
                                           _MENUCONTENTMOVELEFT );
            } else {
                $actions[] = $output->Text( _MENUCONTENTMOVELEFT );
            }

            // condition for being the first item in the category 
            if(( count( $children ) > 0 && $children[0] == $id ) || $id == 1 || $prev_id == 1) {
                $first_item = 1;
            } else {
                $first_item = 0;
            }

            // conditions for the category item can't move "right" are if
            // a) it is a "No Category"
            // b) it's previous category is "No Category"
            // c) it is the first category item of a category
            if( $id == 1 ||                    // No Category
                $prev_id == 1 ||        // Previous category is No Category
                $first_item) {
                $actions[] = $output->Text( _MENUCONTENTMOVERIGHT );
            } else {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcategory",
                                                     array( 'cecatid' => $id,
                                                            'pid' => $prev_id,
                                                            'task' => 'right',
                                                            'authid' => pnSecGenAuthKey() )),
                                           _MENUCONTENTMOVERIGHT );
            }
            $categories2[$id]['actions'] = $actions;
            $prev_id = $id;
        }

        // Start listing all category items
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableStart( _MENUCONTENTVIEWCATS, "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTCONTENTNAME );
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTCONTENTOPTIONS );
        $output->TableColEnd();
        foreach( $categories2 as $id => $category ) {
            if( $category['parent'] == -1 ) {
                CommonExpress_build_viewitems_tree( $output, "cecatid", $curr_cecatid, $categories2, $category, $action);
            }
        }
        $output->TableRowEnd();
        $output->TableEnd();

        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_edit( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($cecatid, $objectid)= pnVarCleanFromInput('cecatid', 'objectid');
    
        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $cecatid = $objectid;
        }

        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnHTML();
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $currlang = pnUserGetLang();
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_category',
                             array('cecatid' => $cecatid));
        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
        // Insert id field with value of ceid so we don't need yet another argument
        // for admin_build_form()
        $item['id'] = $cecatid;
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$item[title]::$item[id]", ACCESS_EDIT)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Add content to output - it helps if all of the module pages have a standard
        // content at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->Text($this->admin_view( array('action' => "editcategory") ));
        $output->Linebreak();
        $output->Text($this->admin_build_form( _MENUCONTENTCATEDIT, _MENUCONTENTUPDATECAT, $item ));
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableStart( "", "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();
   
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_update( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($cecatid, $objectid, $parent_id, $language, $title) = pnVarCleanFromInput('cecatid', 'objectid', 'parent_id', 'language', 'title');
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
                                
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $cecatid = $objectid;
        }                       
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcategory',array('cecatid' => $cecatid) ));
            return true;
        }
    
        if( strlen( trim( $title )) == 0 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGTITLE);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcategory', array('cecatid' => $cecatid) ));
            return true;
        }
    
        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if(pnModAPIFunc('ContentExpress',
                        'admin',
                        'updatecategory',
                        array('cecatid' => $cecatid,
                              'parent_id' => $parent_id,
                              'language' => $language,
                              'title' => $title))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCATUPDATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editcategory',array('cecatid' => $cecatid) ));
    
        // Return
        return true;
    }

    function admin_delete( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($cecatid,
             $objectid,
             $confirmation) = pnVarCleanFromInput('cecatid',
                                                  'objectid',
                                                  'confirmation');
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
         // At this stage we check to see if we have been passed $objectid, the
         // generic item identifier.  This could have been passed in by a hook or
         // through some other function calling this as part of a larger module, but
         // if it exists it overrides $tid
         //
         // Note that this module couuld just use $objectid everywhere to avoid all
         // of this munging of variables, but then the resultant code is less
         // descriptive, especially where multiple objects are being used.  The
         // decision of which of these ways to go is up to the module developer
         if (!empty($objectid)) {
             $cecatid = $objectid;
         }                     
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_category',
                             array('cecatid' => $cecatid));
    
        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$item[title]::$cecatid", ACCESS_DELETE)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Check for confirmation. 
        if (empty($confirmation)) {
            // No confirmation yet - display a suitable form to obtain confirmation
            // of this action from the user
    
            // Create output object - this object will store all of our output so
            // that we can return it easily when required
            $output = new pnHTML();
    
            // Add content to output - it helps if all of the module pages have a
            // standard content at their head to aid in navigation
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
            $output->SetInputMode(_PNH_PARSEINPUT);
    
            // Title - putting a title ad the head of each page reminds the user
            // what they are doing
            $output->Title(_MENUCONTENTCATDELETE);
    
            // Add confirmation to output.  Note that this uses a pnHTML helper
            // function to produce the requested confirmation in a standard
            // fashion.  This not only cuts down on code within the module but
            // allows it to be altered in future without the module developer
            // having to worry about it
            $output->ConfirmAction(_CONFIRMMENUCONTENTCATDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'delcategory'),
                                   _CANCELMENUCONTENTCATDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'newcategory'),
                                   array('cecatid' => $cecatid));
    
            // Return the output that has been generated by this function
            return $output->GetOutput();
        }
    
        // If we get here it means that the user has confirmed the action
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcategory'));
            return true;
        }
    
        // Load API.  All of the actual work for the deletion of the item is done
        // within the API, so we need to load that in before before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if (pnModAPIFunc('ContentExpress',
                         'admin',
                         'deletecategory',
                         array('cecatid' => $cecatid))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCATDELETED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newcategory'));
        
        // Return
        return true;
    }

    function admin_qupdate( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($task, $cecatid, $pid) = pnVarCleanFromInput('task', 'cecatid', 'pid' );
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcategory',array('cecatid' => $cecatid) ));
            return true;
        }
    
        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if(pnModAPIFunc('ContentExpress',
                        'admin',
                        'qupdcategory',
                        array('cecatid' => $cecatid,
                              'pid' => $pid,
                              'task' => $task))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCATUPDATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editcategory', array('cecatid' => $cecatid) ));
    
        // Return
        return true;
    }

    // function to build content form
    function admin_build_form( $title, $btn_label, $item = 0 )
    {
        $output = new pnCEHTML();
        $mytheme = pnUserGetTheme();
        $currlang = pnUserGetLang();
    
        $categories = array();
        if( $item != 0 && !empty( $item ) && $item['id'] != 1) {
            CommonExpress_build_item_list($categories, "categories", $item['id'] );
        }
        else if( $item['id'] != 1 ) {
            CommonExpress_build_item_list($categories, "categories");
        }
    
        // Title - putting a title ad the head of each page reminds the user what
        // they are doing
        $output->Title($title);
    
        // Start form - note the use of pnModURL() to create the recipient URL of
        // this form.  All URLs should be generated through pnModURL() to ensure
        // compatibility with future versions of PostNuke
        $output->UploadMode();
    
        // Start the table that holds the information to be input.  Note how each
        // item in the form is kept logically separate in the code; this helps to
        // see which part of the code is responsible for the display of each item,
        // and helps with future modifications
        $output->TableStart( "", "", 0, "100%", 0, 0 );
    
        if( $item != 0 && !empty( $item )) {
            $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'updatecategory'), 'editcategory');
            $output->FormHidden('cecatid', pnVarPrepForDisplay($item['id']));
        } else {
            $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'createcategory'), 'newcategory');
        }

        // Add an authorisation ID - this adds a hidden field in the form that
        // contains an authorisation ID.  The authorisation ID is very important in
        // preventing certain attacks on the website
        $output->FormHidden('authid', pnSecGenAuthKey());
    
        // Name
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTNAME));
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('title', $item['title'], 64, 64);
        } else {
            $output->FormText('title', '', 64, 64);
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Parent Category
        // parent list should be retreived from database
        $parents = array();
        $parents[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTTOPLEVEL );
        foreach( $categories as $id => $category ) {
            if( $id != 1 ) {
                $parents[] = array( 'id' => $id, 'selected' => 0, 'name' => $category );
            }
        }

        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTPARENT));
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('parent_id', $parents, 0, 1, $item['parent_id'] );
        } else {
            $output->FormSelectMultiple('parent_id', $parents );
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        // Language
        $languages = languagelist();
        $langs = array();
        $langs[] = array( 'id' => 'x_all', 'selected' => 0, 'name' => 'All' );
        foreach( $languages as $l => $lan ) {
            if( $l == $item['language'] || $l == $currlang ) {
                $langs[] = array( 'id' => $l, 'selected' => 1, 'name' => $lan );
            }
            else {
                $langs[] = array( 'id' => $l, 'selected' => 0, 'name' => $lan );
            }
        }
    
        $output->TableColStart( 1, 'left' );

        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTLANG));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('language', $langs, 0, 1, $item['language'] );
        } else {
            $output->FormSelectMultiple('language', $langs );
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        $output->TableEnd();
    
        // End form
        $output->FormSubmit($btn_label);
        $output->CEFormEnd();
    
        return $output->GetOutput();
    }

    function api_get( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($cecatid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql  = "SELECT $categories_column[parent_id],";
        $sql .= "       $categories_column[language],";
        $sql .= "       $categories_column[title] ";
        $sql .= "FROM $categories_table ";
        $sql .= "WHERE $categories_column[id] = " . pnVarPrepForStore($cecatid);

        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
    
        // Check for no rows found, and if so return
        if ($result->EOF) {
            return false;
        }
    
        // Obtain the item information from the result set
        list($parent_id, $language, $title) = $result->fields;
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Security check - important to do this as early on as possible to avoid
        // potential security holes or just too much wasted processing.  Although
        // this one is a bit late in the function it is as early as we can do it as
        // this is the first time we have the relevant information
        if (!pnSecAuthAction(0, 'ContentExpress::Category', "$title::$cecatid", ACCESS_READ)) {
            return false;
        }
    
        // Create the item array
        $item = array('id' => $cecatid,
                      'parent_id' => $parent_id,
                      'language' => $language,
                      'title' => $title,
                      'active' => 1);
    
        // Return the item array
        return $item;
    }

    function api_getall( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        $items = array();
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Category', '::', ACCESS_READ)) {
            return $items;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Get items - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the SelectLimit() command allows for simpler debug
        // operation if it is ever needed
        $sql  = "SELECT $categories_column[id],";
        $sql .= "       $categories_column[parent_id],";
        $sql .= "       $categories_column[title],";
        $sql .= "       $categories_column[language] ";
        $sql .= "FROM $categories_table ";
        $sql .= "ORDER BY $categories_column[title],";
        $sql .= "         $categories_column[parent_id]";
        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _GETFAILED);
            return false;
        }
    
        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $parent_id, $title, $language) = $result->fields;
            if (pnSecAuthAction(0, 'ContentExpress::Category', "::", ACCESS_READ)) {
                $items[] = array('id' => $id,
                                 'parent_id' => $parent_id,
                                 'title' => $title,
                                 'language' => $language,
                                 'active' => 1);
            }
        }
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Return the items
        return $items;
    }

    function api_getsubcategories( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($cecatid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $currlang = pnUserGetLang();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
    
        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql  = "SELECT $categories_column[id],";
        $sql .= "       $categories_column[parent_id],";
        $sql .= "       $categories_column[language],";
        $sql .= "       $categories_column[title] ";
        $sql .= "FROM $categories_table ";
        $sql .= "WHERE $categories_column[parent_id] = " . pnVarPrepForStore($cecatid);

        $result = $dbconn->Execute($sql);
    
        $items = array();
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
    
        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $parent_id, $language, $title) = $result->fields;
            if( pnSecAuthAction(0, 'ContentExpress::Category', "$title::$id", ACCESS_READ) &&
                $cat_id <= 0 && $active ) {
                $items[$id] = array(
                                 'id' => $id,
                                 'parent_id' => $parent_id,
                                 'language' => $language,
                                 'title' => $title,
                                 'active' => 1);
            }
        }
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Return the item array
        return $items;
    }

}
?>
