<?php
// $Id: pninit.php,v 1.2 2003/03/24 07:37:53 bravecobra Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  Initialisation functions for ContentExpress
// ----------------------------------------------------------------------
// 2002/06/10 CC Encapsulate current logic into ContentExpress/MenuExpress

$ModName = basename( dirname( __FILE__ ));

include_once( "modules/$ModName/pnclass/CommonExpress.php" );
include_once( "modules/$ModName/pneditor/pnCEHTML.php" );
include_once( "modules/$ModName/pnclass/Category.php" );
include_once( "modules/$ModName/pnclass/ContentExpress.php" );
include_once( "modules/$ModName/pnclass/MediaExpress.php" );
include_once( "modules/$ModName/pnclass/MenuExpress.php" );

/**
 * initialise the ContentExpress module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function ContentExpress_init()
{
    // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
    // return arrays but we handle them differently.  For pnDBGetConn()
    // we currently just want the first item, which is the official
    // database handle.  For pnDBGetTables() we want to keep the entire
    // tables array together for easy reference later on
    list($dbconn) = pnDBGetConn();

    $content = new ContentExpress();
    $result = $content->init( $dbconn );
    if( $result == false ) return $result;

    $category = new Category();
    $result = $category->init( $dbconn );
    if( $result == false ) return $result;

    $media = new MediaExpress();
    $result = $media->init( $dbconn );
    if( $result == false ) return $result;

    $menu = new MenuExpress();
    $result = $menu->init( $dbconn );
    if( $result == false ) return $result;

    // Initialisation successful
    return true;
}

/**
 * upgrade the ContentExpress module from an old version
 * This function can be called multiple times
 */
function ContentExpress_upgrade($oldversion)
{
    $content = new ContentExpress();
    $result = $content->upgrade($oldversion);
    if( $result == false ) return $result;

    $category = new Category();
    $result = $category->upgrade($oldversion);
    if( $result == false ) return $result;

    $media = new MediaExpress();
    $result = $media->upgrade($oldversion);
    if( $result == false ) return $result;

    $menu = new MenuExpress();
    $result = $menu->upgrade($oldversion);
    if( $result == false ) return $result;

    return true;
}

/**
 * delete the ContentExpress module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function ContentExpress_delete()
{
    $content = new ContentExpress();
    $result = $content->remove();
    if( $result == false ) return $result;

    $category = new Category();
    $result = $category->remove();
    if( $result == false ) return $result;

    $media = new MediaExpress();
    $result = $media->remove();
    if( $result == false ) return $result;

    $menu = new MenuExpress();
    $result = $menu->remove();
    if( $result == false ) return $result;

    // Deletion successful
    return true;
}

?>
