<?php
// $Id: pnuser.php,v 1.7 2003/05/15 09:54:55 bravecobra Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  ContentExpress user display functions
// ----------------------------------------------------------------------

$ModName = basename( dirname( __FILE__ ) );

include_once( "modules/$ModName/pnclass/CommonExpress.php" );
include_once( "modules/$ModName/pneditor/pnCEHTML.php" );
include_once( "modules/$ModName/pnclass/ContentExpress.php" );
include_once( "modules/$ModName/pnclass/MenuExpress.php" );
include_once( "modules/$ModName/pnclass/CommonExpress.php" );
//include_once( "modules/$ModName/pnclass/debugHelper.php" );

/**
 * the main user function
 * This function is the default function, and is called whenever the module is
 * initiated without defining arguments.  As such it can be used for a number
 * of things, but most commonly it either just shows the module menu and
 * returns or calls whatever the module designer feels should be the default
 * function (often this is the view() function)
 */
function ContentExpress_user_main()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    
    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing.  For the
    // main function we want to check that the user has at least overview
    // privilege for some item within this component, or else they won't be
    // able to see anything and so we refuse access altogether.  The lowest
    // level of access for administration depends on the particular module, but
    // it is generally either 'overview' or 'read'
    if (!pnSecAuthAction(0, 'ContentExpress::', '::', ACCESS_READ)) {
        $output->Text(_MENUCONTENTNOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnModFunc('ContentExpress', 'user', 'view'));
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * view items
 * This is a standard function to provide an overview of all of the items
 * available from the module.
 * Figure out which page to display as the first page, get the content id,
 * and then call ContentExpress_user_display() to display it
 */
function ContentExpress_user_view()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing
    if (!pnSecAuthAction(0, 'ContentExpress::', '::', ACCESS_OVERVIEW)) {
        $output->Text(_MENUCONTENTNOAUTH);
        return $output->GetOutput();
    }

    // Get the most top-left menu item and its corresponding content id
    $ceid = pnModGetVar('ContentExpress', 'default_cid');

    pnRedirect( pnModURL('ContentExpress',
                          'user',
                          'display',
                          array( 'ceid' => $ceid,
                                 'meid' => -1 )));
}

/**
 * display item
 * This is a standard function to provide detailed informtion on a single item
 * available from the module.
 * The page is compose of four different major areas:
 * 1) content parents path hyper links to provide quick access to parent content
 * 2) immediate childrens' title hyper links if any
 *    (those WITH menu item reference ONLY)
 * 3) title of the current content
 * 4) the current content including any immediate sub-contents
 *    (immediate children content WITHOUT menu item reference ONLY)
 */
function ContentExpress_user_display($args)
{
    $content = new ContentExpress();
    return $content->user_display( $args);
}

/**
 * print item
 * This is a standard function to provide detailed informtion on a single item
 * available from the module.
 * The page is compose of four different major areas:
 * 1) content parents path hyper links to provide quick access to parent content
 * 2) immediate childrens' title hyper links if any
 *    (those WITH menu item reference ONLY)
 * 3) title of the current content
 * 4) the current content including any immediate sub-contents
 *    (immediate children content WITHOUT menu item reference ONLY)
 */
function ContentExpress_user_print($args)
{
    $content = new ContentExpress();
    return $content->user_print( $args );
}

/**
 * generate menu fragment
 */
function ContentExpress_user_usermenu($args)
{
    $menu = new MenuExpress();
    return $menu->user_menu( $args );
}

function ContentExpress_user_sendfriend($args)
{
    $content = new ContentExpress();
    return $content->user_sendfriend( $args );
}

function ContentExpress_user_mailfriend($args)
{
    $content = new ContentExpress();
    return $content->user_mailfriend( $args );
}

function ContentExpress_user_mailsent($args)
{
    $content = new ContentExpress();
    return $content->user_mailsent( $args );
}
?>
