<?php
// $Id: pnuserapi.php,v 1.6 2003/04/24 15:04:29 bravecobra Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  ContentExpress user API
// ----------------------------------------------------------------------

$ModName = basename( dirname( __FILE__ ));
include_once( "modules/$ModName/pnclass/CommonExpress.php" );
include_once( "modules/$ModName/pneditor/pnCEHTML.php" );
include_once( "modules/$ModName/pnclass/Category.php" );
include_once( "modules/$ModName/pnclass/ContentExpress.php" );
include_once( "modules/$ModName/pnclass/MenuExpress.php" );
//include_once( "modules/$ModName/pnclass/debugHelper.php" );

/**
 * get all example category items
 * @returns array
 * @return array of items, or false on failure
 */
function ContentExpress_userapi_getall_categories($args)
{
    $category = new Category();
    return $category->api_getall( $args );
}

/**
 * get a specific category item
 * @param $args['ceid'] id of example category item to get
 * @returns array
 * @return item array, or false on failure
 */
function ContentExpress_userapi_get_category($args)
{
    $category = new Category();
    return $category->api_get( $args );
}

/**
 * get all sub-category item for given category id
 * @param $args['ceid'] id of example category item to get
 * @returns array
 * @return item array, or false on failure
 */
function ContentExpress_userapi_getall_subcategories($args)
{
    $category = new Category();
    return $category->api_getsubcategories( $args );
}

/**
 * get all example content items
 * @returns array
 * @return array of items, or false on failure
 */
function ContentExpress_userapi_getall_contentitems($args)
{
    $content = new ContentExpress();
    return $content->api_getall( $args );
}

/**
 * get a specific content item
 * @param $args['ceid'] id of example content item to get
 * @returns array
 * @return item array, or false on failure
 */
function ContentExpress_userapi_get_contentitem($args)
{
    $content = new ContentExpress();
    return $content->api_get( $args );
}

/**
 * get all sub-content item for given content id
 * @param $args['ceid'] id of example content item to get
 * @returns array
 * @return item array, or false on failure
 */
function ContentExpress_userapi_getall_subcontentitems($args)
{
    $content = new ContentExpress();
    return $content->api_getallchild( $args );
}

/**
 * get all example menu items
 * @returns array
 * @return array of items, or false on failure
 */
function ContentExpress_userapi_getall_menuitems($args)
{
    $menu = new MenuExpress();
    return $menu->api_getall( $args );
}

/**
 * get a specific menu item
 * @param $args['mid'] id of example menu item to get
 * @returns array
 * @return item array, or false on failure
 */
function ContentExpress_userapi_get_menuitem($args)
{
    $menu = new MenuExpress();
    return $menu->api_get( $args );
}

/**
 * get all example layout items
 * @returns array
 * @return array of items, or false on failure
 */
function ContentExpress_userapi_getall_layoutitems($args)
{
    $content = new ContentExpress();
    return $content->api_getlayouts( $args );
}

function ContentExpress_userapi_getall_statusitems($args)
{
    $content = new ContentExpress();
    return $content->api_getstatuses( $args );
}

//function to increase the times read field of an article
function ContentExpress_userapi_updateread($args)
{
    $content = new ContentExpress();
    return $content->api_updateread( $args );
}
?>
