<?php

// $Id: ContentExpress.php,v 1.33 2003/05/26 14:24:18 linuxwarrior Exp $
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://www.widgetbox.net/
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  ContentExpress class
// ----------------------------------------------------------------------

$ModName = basename( dirname( dirname( __FILE__ )));

class ContentExpress
{
    // Called by pntables.php
    function pntables( &$pntable )
    {
        // Get the name for the content item table.  This is not necessary
        // but helps in the following statements and keeps them readable
        $contentitems = pnConfigGetVar('prefix') . '_ce_contentitems';
    
        // Set the table name
        $pntable['ce_contentitems'] = $contentitems;
    
        // Set the column names.  Note that the array has been formatted
        // on-screen to be very easy to read by a user.
        $pntable['ce_contentitems_column'] = array(
            'id'                => $contentitems . '.mc_id',
            'parent_id'         => $contentitems . '.mc_parent_id',
            'cat_id'            => $contentitems . '.mc_cat_id',            // category id
            'language'          => $contentitems . '.mc_language',
            'title'             => $contentitems . '.mc_title',
            'title_align'       => $contentitems . '.mc_title_align',
            'text'              => $contentitems . '.mc_text',
            'enable_title'      => $contentitems . '.mc_enable_title',
            'media_url'         => $contentitems . '.mc_media_url',
            'media_width'       => $contentitems . '.mc_media_width',
            'media_height'      => $contentitems . '.mc_media_height',
            'media_text'        => $contentitems . '.mc_media_text',
            'layout_id'         => $contentitems . '.mc_layout_id',
            'start_date'        => $contentitems . '.mc_start_date',
            'end_date'          => $contentitems . '.mc_end_date',
            'top_print'         => $contentitems . '.mc_top_print',
            'bottom_print'      => $contentitems . '.mc_bottom_print',
            'status'            => $contentitems . '.mc_status', // preview, posted
            'weight'            => $contentitems . '.mc_weight',
            'navigation'        => $contentitems . '.mc_navigation',
            'top_sendfriend'    => $contentitems . '.mc_top_sendfriend',
            'bottom_sendfriend' => $contentitems . '.mc_bottom_sendfriend',
            'bottom_sendfriend' => $contentitems . '.mc_bottom_sendfriend',
            'backgroundcolor'   => $contentitems . '.mc_backgroundcolor',
            'last_updated'      => $contentitems . '.mc_last_updated',
            'times_read'        => $contentitems . '.mc_times_read',
            'show_last_updated' => $contentitems . '.mc_show_last_updated',
            'show_times_read'   => $contentitems . '.mc_show_times_read',
            'author'            => $contentitems . '.mc_author',
            'notes'             => $contentitems . '.mc_notes');

        // Get the name for the layout item table.  This is not necessary
        // but helps in the following statements and keeps them readable
        $layout = pnConfigGetVar('prefix') . '_ce_layout';

        // Set the table name
        $pntable['ce_layout'] = $layout;
    
        // Set the column names.  Note that the array has been formatted
        // on-screen to be very easy to read by a user.
        $pntable['ce_layout_column'] = array('id'          => $layout . '.mc_id',
                                             'name'        => $layout . '.mc_name',
                                             'description' => $layout . '.mc_description',
                                             'text'        => $layout . '.mc_text');

        // Get the name for the content state table.  This is not necessary
        // but helps in the following statements and keeps them readable
        $statuses = pnConfigGetVar('prefix') . '_ce_statuses';
    
        // Set the table name
        $pntable['ce_statuses'] = $statuses;
    
        // Set the column names.  Note that the array has been formatted
        // on-screen to be very easy to read by a user.
        $pntable['ce_statuses_column'] = array(
            'id'           => $statuses . '.mc_id',
            'parent_id'    => $statuses . '.mc_parent_id',
            'title'        => $statuses . '.mc_title',
            'language'     => $statuses . '.mc_language');
    }

    // Called by pninit.php
    function init( $dbconn )
    {
        $pntable = pnDBGetTables();

        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];

        $now = strftime( "%Y-%m-%d %H:%M:%S", time());

        // Create the table - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating out
        // the SQL statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "CREATE TABLE $contentitems_table (";
        $sql .= "$contentitems_column[id] int(11) NOT NULL auto_increment,";
        $sql .= "$contentitems_column[parent_id] int(11) NOT NULL default -1,";
        $sql .= "$contentitems_column[cat_id] int(11) NOT NULL default -1,";
        $sql .= "$contentitems_column[language] varchar(30) NOT NULL,";
        $sql .= "$contentitems_column[title] text NOT NULL,";
        $sql .= "$contentitems_column[title_align] tinyint(4) NOT NULL default 1,";
        $sql .= "$contentitems_column[text] longtext NOT NULL,";
        $sql .= "$contentitems_column[enable_title] tinyint(4) NOT NULL default 1,";
        $sql .= "$contentitems_column[media_url] text NULL,";
        $sql .= "$contentitems_column[media_width] int(11) NOT NULL default 0,";
        $sql .= "$contentitems_column[media_height] int(11) NOT NULL default 0,";
        $sql .= "$contentitems_column[media_text] text NULL,";
        $sql .= "$contentitems_column[layout_id] int(11) NOT NULL default -1,";
        $sql .= "$contentitems_column[start_date] datetime NOT NULL default '$now',";
        $sql .= "$contentitems_column[end_date] datetime NOT NULL default '2038-01-18 00:00:00',";
        $sql .= "$contentitems_column[top_print] tinyint(4) NOT NULL default 0,";
        $sql .= "$contentitems_column[bottom_print] tinyint(4) NOT NULL default 0,";
        $sql .= "$contentitems_column[status] tinyint(4) NOT NULL default '1',";
        $sql .= "$contentitems_column[weight] float NOT NULL default 0,";
        $sql .= "$contentitems_column[navigation] tinyint(4) NOT NULL default 0,";
        $sql .= "$contentitems_column[top_sendfriend] tinyint(4) NOT NULL default 1,";
        $sql .= "$contentitems_column[bottom_sendfriend] tinyint(4) NOT NULL default 0,";
        $sql .= "$contentitems_column[backgroundcolor] varchar(7) NOT NULL ,";
        $sql .= "$contentitems_column[last_updated] datetime NOT NULL default '$now',";
        $sql .= "$contentitems_column[times_read] int(11) NOT NULL default 0,";
        $sql .= "$contentitems_column[show_last_updated] tinyint(4) NOT NULL default 1,";
        $sql .= "$contentitems_column[show_times_read] tinyint(4) NOT NULL default 1,";
        $sql .= "$contentitems_column[author] varchar(30) NOT NULL default '',";
        $sql .= "$contentitems_column[notes] text NULL ,";
        $sql .= "PRIMARY KEY (mc_id))";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $contentitems_table");
            return false;
        }
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $layout_table = $pntable['ce_layout'];
        $layout_column = &$pntable['ce_layout_column'];
    
        // Create the table - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating out
        // the SQL statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "CREATE TABLE $layout_table (";
        $sql .= "$layout_column[id] int(11) NOT NULL auto_increment,";
        $sql .= "$layout_column[name] text NOT NULL,";
        $sql .= "$layout_column[description] text NOT NULL,";
        $sql .= "$layout_column[text] text NOT NULL,";
        $sql .= "PRIMARY KEY (mc_id));";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $layout_table");
            return false;
        }
    
        // Add Top Left
        $sql  = "INSERT INTO $layout_table (
                 $layout_column[id],
                 $layout_column[name],
                 $layout_column[description],
                 $layout_column[text])
                 VALUES (
                 '1',
                 'TopLeft',
                 'Image aligned to left with vertical alignment to top',
                 'Top Left' );";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $layout_table");
            return false;
        }
    
        // Add basic layout type
        $sql = "INSERT INTO $layout_table (
                $layout_column[id],
                $layout_column[name],
                $layout_column[description],
                $layout_column[text])
                VALUES (
                '2',
                'TopRight',
                'Image aligned to right with vertical alignment to top',
                'Top Right' ),
                (
                '3',
                'BottomLeft',
                'Image aligned to left with vertical alignment to bottom',
                'Bottom Left' ),
                (
                '4',
                'BottomRight',
                'Image aligned to right with vertical alignment to bottom',
                'Bottom Right' ),
                (
                '5',
                'Top',
                'Image aligned to center with vertical alignment to top',
                'Top' ),
                (
                '6',
                'Bottom',
                'Image aligned to center with vertical alignment to bottom',
                'Bottom' );";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $layout_table");
            return false;
        }

        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $statuses_table = $pntable['ce_statuses'];
        $statuses_column = &$pntable['ce_statuses_column'];
    
        // Create the table - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating out
        // the SQL statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql  = "CREATE TABLE $statuses_table (";
        $sql .= "$statuses_column[id] int(11) NOT NULL auto_increment,";
        $sql .= "$statuses_column[parent_id] int(11) NOT NULL default -1,";
        $sql .= "$statuses_column[title] text NOT NULL,";
        $sql .= "$statuses_column[language] varchar(30) NOT NULL,";
        $sql .= "PRIMARY KEY (mc_id))";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $statuses_table");
            return false;
        }
    
        // Add Basic State
        $sql = "INSERT INTO $statuses_table (
                $statuses_column[id],
                $statuses_column[parent_id],
                $statuses_column[title],
                $statuses_column[language])
                VALUES (
                '1',
                '-1',
                'Preview',
                'x_all' ),
                (
                '2',
                '-1',
                'Posted',
                'x_all' );";
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $statuses_table");
            return false;
        }

        // Set up an initial value for a module variable.  Note that all module
        // variables should be initialised with some value in this way rather
        // than just left blank, this helps the user-side code and means that
        // there doesn't need to be a check to see if the variable is set in
        // the rest of the code as it always will be
        pnModSetVar('ContentExpress', 'default_cid', -2);//showing index page now
        pnModSetVar('ContentExpress', 'default_url', "");

        // Quick admin link from content page
        pnModSetVar('ContentExpress', 'enable_qadmin', 1 );
        pnModSetVar('ContentExpress', 'enable_aclean', 0 );

        // Printing
        pnModSetVar('ContentExpress', 'enable_top_print', 1 );
        pnModSetVar('ContentExpress', 'enable_bottom_print', 0 );

        // WYSIWYG editor
        pnModSetVar('ContentExpress', 'enable_wysiwyg', 'ie2' );
        pnModSetVar('ContentExpress', 'wysiwyg_height', 60 );
        pnModSetVar('ContentExpress', 'wysiwyg_width', 80 );
        pnModSetVar('ContentExpress', 'enable_display_navigation', 1);
        pnModSetVar('ContentExpress', 'index_depth', -1);

        // Send ContentItem to friend
        pnModSetVar('ContentExpress', 'enable_top_sendfriend', 1 );
        pnModSetVar('ContentExpress', 'enable_bottom_sendfriend', 0 );

        //Article Stats
        pnModSetVar('ContentExpress', 'show_last_updated', 1 );
        pnModSetVar('ContentExpress', 'show_times_read', 1 );
        pnModSetVar('ContentExpress', 'timeformat', '%Y-%m-%d %H:%M:%S');
        pnModSetVar('ContentExpress', 'show_times_read_index', 1 );
        pnModSetVar('ContentExpress', 'show_author_index', 0 );

        return true;
    }

    // Called by pninit.php
    function upgrade($oldversion)
    {
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // Update successful
        switch($oldversion) {
            case "1.0":
                // Rename image_url to media_url, add media_type to content items table
                // Remove image_url from layout table
                // Module variables' name have changed in version 1.1
    
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $contentitems_table = pnConfigGetVar('prefix') . '_ContentExpress_contentitems';
    
                // Change content items table to add media_type, media_width, media_height, rename
                // mc_image_url to mc_media_url
                $sql = "ALTER TABLE $contentitems_table
                        CHANGE mc_image_url mc_media_url TEXT DEFAULT NULL,
                        ADD mc_media_type TEXT NOT NULL AFTER mc_media_url,
                        ADD mc_media_width INT NOT NULL DEFAULT '0' AFTER mc_media_type,
                        ADD mc_media_height INT NOT NULL DEFAULT '0' AFTER mc_media_width";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - add media fields $contentitems_table");
                    return false;
                }
    
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $layout_table = pnConfigGetVar('prefix') . '_ContentExpress_layout';
    
                // Remove image_url from layout table
                $sql = "ALTER TABLE $layout_table DROP mc_image_url";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - drop image url $layout_table");
                    return false;
                }
    
                // Default media dimension for display
                pnModSetVar('ContentExpress', 'media_width', 0 );
                pnModSetVar('ContentExpress', 'media_height', 0 );
    
                // image_types renamed to be media_types
                $media_types = pnModGetVar('ContentExpress', 'image_types');
                pnModSetVar('ContentExpress', 'media_types', $media_types );
                pnModDelVar('ContentExpress', 'image_types');
    
                // max_image_size renamed to be max_media_size
                $max_media_size = pnModGetVar('ContentExpress', 'max_image_size');
                pnModSetVar('ContentExpress', 'max_media_size', $max_media_size );
                pnModDelVar('ContentExpress', 'max_image_size');
    
                // image_repository renamed to be media_repository
                $media_repository = pnModGetVar('ContentExpress', 'image_repository');
                pnModSetVar('ContentExpress', 'media_repository', $media_repository);
                pnModDelVar('ContentExpress', 'image_repository');
    
            case "1.1":
            case "1.1b":
            case "1.1c":
                // Quick admin link from content page
                pnModSetVar('ContentExpress', 'enable_qadmin', 1 );
                pnModSetVar('ContentExpress', 'enable_aclean', 0 );
                // Printing
                pnModSetVar('ContentExpress', 'enable_top_print', 1 );
                pnModSetVar('ContentExpress', 'enable_bottom_print', 0 );
            case "1.1d":
                // Printing
                pnModSetVar('ContentExpress', 'enable_top_print', 1 );
                pnModSetVar('ContentExpress', 'enable_bottom_print', 0 );
            case "1.2":
                pnModSetVar('ContentExpress', 'enable_wysiwyg', 1 );
                pnModSetVar('ContentExpress', 'pnmenu_style', 0 );

                // Config table is obseleted
                // Get the name for the content item table.  This is not necessary
                // but helps in the following statements and keeps them readable
                $config = pnConfigGetVar('prefix') . '_ContentExpress_config';
    
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $sql = "DROP TABLE $config";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - drop table $config");
                    return false;
                }
            case "1.2.1":
                // Fix bug in language setting for content item. The newer version
                // of PN seems to change the All language from '' to 'x_all'
                $contentitems_table = pnConfigGetVar('prefix') . '_ContentExpress_contentitems';

                // Change content items table to fix language related information
                // mc_image_url to mc_media_url
                $sql = "UPDATE $contentitems_table
                        SET mc_language = 'x_all'
                        WHERE mc_language = ''";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - change language default $contentitems_table");
                    return false;
                }

            case "1.2.2a":
                // Fix bug in language setting for content item. The newer version
                // of PN seems to change the All language from '' to 'x_all'
                $contentitems_table = pnConfigGetVar('prefix') . '_ContentExpress_contentitems';
                
		// Change content items table to remove media_type
                // mc_image_url to mc_media_url
                $sql = "ALTER TABLE $contentitems_table
                        DROP mc_media_type";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - drop media type $contentitems_table");
                    return false;
                }
    
            case "1.2.2":
            case "1.2.3":
    
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $contentitems_table = pnConfigGetVar('prefix') . '_ContentExpress_contentitems';

                $now = strftime( "%Y-%m-%d %H:%M:%S", time());

                // Change content items table to add media_type, media_width, media_height, rename
                // mc_image_url to mc_media_url
                $sql = "ALTER TABLE $contentitems_table
                        ADD mc_media_text TEXT AFTER mc_media_height,
                        ADD mc_start_date DATETIME NOT NULL DEFAULT '$now' AFTER mc_layout_id,
                        ADD mc_end_date DATETIME NOT NULL DEFAULT '2038-01-18 00:00:00' AFTER mc_start_date,
                        ADD mc_top_print TINYINT(4) NOT NULL DEFAULT '0' AFTER mc_end_date,
                        ADD mc_bottom_print TINYINT(4) NOT NULL DEFAULT '0' AFTER mc_top_print,
                        ADD mc_counter INT NOT NULL DEFAULT '0' AFTER mc_bottom_print,
                        ADD mc_status VARCHAR(16) NOT NULL DEFAULT 'Draft' AFTER mc_counter";
                $dbconn->Execute($sql);
    
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - change schema $contentitems_table");
                    return false;
                }

                $layout_table = pnConfigGetVar('prefix') . '_ContentExpress_layout';
                $sql = "INSERT INTO $layout_table (
                        mc_id,
                        mc_name,
                        mc_description,
                        mc_text)
                        VALUES (
                        '5',
                        'Top',
                        'Image aligned to center with vertical alignment to top',
                        'Top' ),
                        (
                        '6',
                        'Bottom',
                        'Image aligned to center with vertical alignment to bottom',
                        'Bottom' );";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - add top/bottom image alignment $layout_table");
                    return false;
                }

            case "1.2.4":
            case "1.2.4.1":
            case "1.2.4.2":
                pnModSetVar( 'ContentExpress', 'enable_wysiwyg', 'ie2' );
                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $contentitems_table = $pntable['ce_contentitems'];
                $contentitems_column = &$pntable['ce_contentitems_column'];
    
                // Change the name of the tables with the new convention
                $old_contentitems_table = pnConfigGetVar('prefix') . '_ContentExpress_contentitems';

                $sql = "ALTER TABLE $old_contentitems_table
                        RENAME AS $contentitems_table";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Rename $old_contentitems_table to $contentitems_table");
                    return false;
                }

                // Set status of all existing contents to 2 (aka posted)
                $sql = "UPDATE $contentitems_table
                        SET $contentitems_column[status] = '2'
                       ";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Update status $contentitems_table");
                    return false;
                }

                // Change content items table to remove menu_id, add cat_id
                $sql = "ALTER TABLE $contentitems_table
                        DROP mc_menu_id,
                        ADD mc_cat_id INT(11) NOT NULL DEFAULT -1 AFTER mc_parent_id,
                        CHANGE mc_text mc_text LONGTEXT NOT NULL,
                        CHANGE mc_status mc_status TINYINT(4) NOT NULL DEFAULT '1',
                        DROP mc_enable_mp";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Alter schema $contentitems_table");
                    return false;
                }

                // Change set all content category to 1
                $sql = "UPDATE $contentitems_table
                        SET $contentitems_column[cat_id] = 1";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Assign default category $contentitems_table");
                    return false;
                }

                // Set start/end time of all existing contents
                // Set top_print/bottom_print based upon current global setting for printing
                $now = strftime( "%Y-%m-%d %H:%M:%S", time());
                $sql = "UPDATE $contentitems_table
                        SET $contentitems_column[start_date] = '$now',
                            $contentitems_column[end_date] = '2038-01-18 00:00:00'";
                if( pnModGetVar('ContentExpress', 'enable_top_print')) {
                    $sql .= ", $contentitems_column[top_print] = 1";
                }
                if( pnModGetVar('ContentExpress', 'enable_bottom_print')) {
                    $sql .= ", $contentitems_column[bottom_print] = 1";
                }
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Update start/end date $contentitems_table");
                    return false;
                }

                // It's good practice to name the table and column definitions you
                // are getting - $table and $column don't cut it in more complex
                // modules
                $statuses_table = $pntable['ce_statuses'];
                $statuses_column = &$pntable['ce_statuses_column'];
    
                // Create the table - the formatting here is not mandatory, but it does
                // make the SQL statement relatively easy to read.  Also, separating out
                // the SQL statement from the Execute() command allows for simpler
                // debug operation if it is ever needed
                $sql  = "CREATE TABLE $statuses_table (";
                $sql .= "$statuses_column[id] int(11) NOT NULL auto_increment,";
                $sql .= "$statuses_column[parent_id] int(11) NOT NULL default '-1',";
                $sql .= "$statuses_column[title] text NOT NULL,";
                $sql .= "$statuses_column[language] varchar(30) NOT NULL,";
                $sql .= "PRIMARY KEY (mc_id))";
            
                $dbconn->Execute($sql);
            
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - $statuses_table");
                    return false;
                }

                // Add Basic State
                $sql = "INSERT INTO $statuses_table (
                        $statuses_column[id],
                        $statuses_column[parent_id],
                        $statuses_column[title],
                        $statuses_column[language])
                        VALUES
                        (
                        '1',
                        '-1',
                        'Preview',
                        'x_all' ),
                        (
                        '2',
                        '-1',
                        'Posted',
                        'x_all' );";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _CREATETABLEFAILED ." - insert default statuses $statuses_table");
                    return false;
                }

                // Rename the layout table to new convention
                $old_layout_table = pnConfigGetVar('prefix') . '_ContentExpress_layout';
                $layout_table = $pntable['ce_layout'];

                $sql = "ALTER TABLE $old_layout_table
                        RENAME AS $layout_table";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Rename $old_layout_table to $layout_table");
                    return false;
                }

                // Set the WYSIWYG editor to ie2
                pnModSetVar('ContentExpress', 'enable_wysiwyg', 'ie2' );

            case "1.2.4.3":
            case "1.2.4.4":
            case "1.2.4.5":
                // Add configuratable wysiwyg editor dimension
                pnModSetVar('ContentExpress', 'wysiwyg_height', 60 );
                pnModSetVar('ContentExpress', 'wysiwyg_width', 80 );
            case "1.2.4.6":
            case "1.2.4.7":
            case "1.2.4.8":
            case "1.2.4.9":
	        $contentitems_table = $pntable['ce_contentitems'];
                $contentitems_column = &$pntable['ce_contentitems_column'];
                $now = strftime( "%Y-%m-%d %H:%M:%S", time());
                // Add Basic State
                $sql = "ALTER TABLE $contentitems_table
                        DROP mc_active,
                        ADD $contentitems_column[navigation] TINYINT( 4 ) DEFAULT '0' NOT NULL,
                        ADD $contentitems_column[top_sendfriend] TINYINT( 4 ) DEFAULT '1' NOT NULL,
                        ADD $contentitems_column[bottom_sendfriend] TINYINT( 4 ) DEFAULT '0' NOT NULL,
                        ADD $contentitems_column[backgroundcolor] varchar(7) NOT NULL ,
                        ADD $contentitems_column[last_updated] datetime NOT NULL default '$now',
                        ADD $contentitems_column[times_read] int(11) NOT NULL default '0',
                        ADD $contentitems_column[show_last_updated] tinyint(4) NOT NULL default '1',
                        ADD $contentitems_column[show_times_read] tinyint(4) NOT NULL default '1';";

                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Adding fields $contentitems_table");
                    return false;
                }

                //update the current contentitems
                $sql = "UPDATE $contentitems_table SET $contentitems_column[times_read] = 0,
                                                       $contentitems_column[last_updated] = '$now';";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Updating fields $contentitems_table");
                    return false;
                }

                pnModSetVar('ContentExpress', 'enable_display_navigation', 1);
                pnModSetVar('ContentExpress', 'index_depth', -1);
                pnModSetVar('ContentExpress', 'enable_top_sendfriend', 1 );
                pnModSetVar('ContentExpress', 'enable_bottom_sendfriend', 0 );
                pnModSetVar('ContentExpress', 'show_last_updated', 1 );
                pnModSetVar('ContentExpress', 'show_times_read', 1 );
                pnModSetVar('ContentExpress', 'timeformat', '%Y-%m-%d %H:%M:%S');
                pnModSetVar('ContentExpress', 'show_times_read_index', 1 );
                if (pnModGetVar('ContentExpress', 'enable_wysiwyg') == 'ie')
                {
                    pnModSetVar('ContentExpress', 'enable_wysiwyg', 'ie2');
                }

            case "1.2.4.10":
	        $contentitems_table = $pntable['ce_contentitems'];
                $sql = "ALTER TABLE $contentitems_table
                        DROP mc_counter";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Drop field mc_counter $contentitems_table");
                    return false;
                }
            case "1.2.5.2":
                $contentitems_table = $pntable['ce_contentitems'];
                $contentitems_column = &$pntable['ce_contentitems_column'];
                $sql = "ALTER TABLE $contentitems_table ";
                $sql .= "ADD $contentitems_column[title_align] tinyint(4) NOT NULL default '1';";
                $dbconn->Execute($sql);
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Add field mc_title_align $contentitems_table $sql");
                    return false;
                }
            case "1.2.5.3":
                $contentitems_table = $pntable['ce_contentitems'];
                $contentitems_column = &$pntable['ce_contentitems_column'];
                $sql = "ALTER TABLE $contentitems_table ";
                $sql .= "ADD $contentitems_column[author] varchar(30) NOT NULL, ";
                $sql .= "ADD $contentitems_column[notes] text NULL;";
                $dbconn->Execute($sql);
                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _UPDATETABLEFAILED ." - Add fields author, notes  $contentitems_table $sql");
                    return false;
                }
                //add the author label switch to vars
                pnModSetVar('ContentExpress', 'show_author_index', 0 );

            case "1.2.5.4":
            break;
        }
        return true;
    }

    // Called by pninit.php
    function remove()
    {
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // Drop the table - for such a simple command the advantages of separating
        // out the SQL statement from the Execute() command are minimal, but as
        // this has been done elsewhere it makes sense to stick to a single method
        $sql = "DROP TABLE $pntable[ce_contentitems]";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Report failed deletion attempt
            pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[ce_contentitems]");
            return false;
        }
    
        // Drop the table - for such a simple command the advantages of separating
        // out the SQL statement from the Execute() command are minimal, but as
        // this has been done elsewhere it makes sense to stick to a single method
        $sql = "DROP TABLE $pntable[ce_layout]";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Report failed deletion attempt
            pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[ce_layout]");
            return false;
        }
    
        // Drop the table - for such a simple command the advantages of separating
        // out the SQL statement from the Execute() command are minimal, but as
        // this has been done elsewhere it makes sense to stick to a single method
        $sql = "DROP TABLE $pntable[ce_statuses]";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            // Report failed deletion attempt
            pnSessionSetVar('errormsg', _DELETETABLEFAILED ." - $pntable[ce_statuses]");
            return false;
        }
    
        // Delete any module variables
        pnModDelVar('ContentExpress', 'default_cid' );
        pnModDelVar('ContentExpress', 'default_url' );
        pnModDelVar('ContentExpress', 'enable_qadmin' );
        pnModDelVar('ContentExpress', 'enable_aclean' );
        pnModDelVar('ContentExpress', 'enable_wysiwyg' );
        pnModDelVar('ContentExpress', 'wysiwyg_height' );
        pnModDelVar('ContentExpress', 'wysiwyg_width' );
        pnModDelVar('ContentExpress', 'enable_top_print' );
        pnModDelVar('ContentExpress', 'enable_bottom_print' );
        pnModDelVar('ContentExpress', 'enable_display_navigation');
        pnModDelVar('ContentExpress', 'index_depth');
        pnModDelVar('ContentExpress', 'enable_top_sendfriend');
        pnModDelVar('ContentExpress', 'enable_bottom_sendfriend');
        pnModDelVar('ContentExpress', 'show_last_updated');
        pnModDelVar('ContentExpress', 'show_times_read');

        return true;
    }

    // Will be called by pnversion.php
    function version( &$modversion )
    {
        $modversion['name'] = 'ContentExpress';
        $modversion['version'] = '1.2.6.0';
        $modversion['description'] = 'Content Management Module';
        $modversion['credits'] = 'docs/credits.txt';
        $modversion['help'] = 'docs/help.txt';
        $modversion['changelog'] = 'docs/changelog.txt';
        $modversion['license'] = 'docs/license.txt';
        $modversion['official'] = 0;
        $modversion['author'] = 'Chester Chee, Brave Cobra, Jorn Lind-Nielsen';
        $modversion['contact'] = 'http://xexpress.sourceforge.net/';
        $modversion['admin'] = 1;
        $modversion['securityschema'] = array(
                                            'ContentExpress::Content' => ':Content title:Content ID',
                                            'ContentExpress::Contentblock' => 'Block title::Block ID',
                                            'ContentExpress::Layout' => 'Layout title::ID'
                                             );
    }

    // Administrative API helper methods
    // API create
    function api_create($args)
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($parent_id)) || (!isset($cat_id)) || (!isset($language)) ||
            (!isset($title)) || (!isset($title_align)) || (!isset($text)) ||
            (!isset($status)) || (!isset($weight))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
        $now = strftime( "%Y-%m-%d %H:%M:%S", time());
        if( empty($enable_title)) { $enable_title = 0; }
        if( empty($media_url)) { $media_url = ""; }
        if( empty($media_width)) { $media_width = 0; }
        if( empty($media_height)) { $media_height = 0; }
        if( empty($media_text)) { $media_text = ""; }
        if( empty($layout_id)) { $layout_id = 1; }
        if( empty($upld_media)) { $upld_media = ""; }
        if( empty($upld_media_name)) { $upld_media_name = ""; }
        if( empty($upld_media_type)) { $upld_media_type = ""; }
        if( empty($upld_media_size)) { $upld_media_size = 0; }
        if( empty($top_print)) { $top_print = 0; }
        if( empty($bottom_print)) { $bottom_print = 0; }
        if( empty($start_date)) { $start_date = $now; }
        // This is the approx. last date that 32-bit value can handle
        if( empty($end_date)) { $end_date = "2038-01-18 00:00:00"; }
        if( empty($navigation)) { $navigation = 0; }
        if( empty($top_sendfriend)) { $top_sendfriend = 0; }
        if( empty($bottom_sendfriend)) { $bottom_sendfriend = 0; }
        if( empty($backgroundcolor)) { $backgroundcolor = ''; }
        if( empty($last_updated)) { $last_updated = $now; }
        if( empty($times_read)) { $times_read = 0; }
        if( empty($show_last_updated)) { $show_last_updated = 0; }
        if( empty($show_times_read)) { $show_times_read = 0; }
        if( empty($author)) { $author = pnUserGetVar('name'); }
        if( empty($notes)) { $notes = ""; }

        // Security check - important to do this as early on as possible to
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Content', "::", ACCESS_ADD)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }

        // Move the media file to designate directory
        if( strcmp( $upld_media, "none" ) != 0 &&
            strcmp( $upld_media, "" ) != 0 ) {

            // Verify the media file type if appropriate
            $media_types = pnModGetVar( 'MediaExpress', 'media_types' );
            if ( strlen($upld_media_name) > 0 &&
                 strlen($upld_media_type) > 0 &&
                 substr_count($media_types,$upld_media_type) <= 0 ) {
                pnSessionSetVar('errormsg', _MENUCONTENTBADIMGTYPE);
                return false;
            }

            // Verify the size of the media file
            $max_media_size = pnModGetVar( 'MediaExpress', 'max_media_size' );
            if( strlen($upld_media_name) > 0 &&
                $max_media_size < $upld_media_size ) {
                pnSessionSetVar('errormsg', _MENUCONTENTIMGTOOBIG);
                return false;
            }
    
            $media_repository = pnModGetVar( 'MediaExpress', 'media_repository' );
    
            if( is_uploaded_file( $upld_media )) {
                if( !move_uploaded_file( $upld_media, "modules/ContentExpress/".$media_repository."/".$upld_media_name )) {
                    pnSessionSetVar('errormsg', _MENUCONTENTIMGCOPYFAILED);
                    return false;
                }
                // bug fix provided by pini, many thanks!!
                chmod("modules/ContentExpress/$media_repository/$upld_media_name", 0644);
            }
    
            // Update the media url in the content
            $media_url = $media_repository."/".$upld_media_name;
            $media_type = $upld_media_type;
        } else {
            $media_type = "";
        }
    
        // Verify the start and end date values are good
        $start_time = strtotime( $start_date );
        $end_time = strtotime( $end_date );
        if( $start_time < 0 || $end_time < 0 ||
            (($end_time <= $start_time ) && $end_time > 0 )) {
            pnSessionSetVar('errormsg', _MENUCONTENTBADDATE);
            return false;
        }

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
    
        // Get the max weight for the current item with the corresponding parent id
        $sql = "SELECT MAX($contentitems_column[weight])
                FROM $contentitems_table
                WHERE $contentitems_column[parent_id] = $parent_id";
    
        $result = $dbconn->Execute($sql);
    
        if( $result != false ) {
            list( $max_weight ) = $result->fields;
            if( !empty( $max_weight )) {
                $weight = $max_weight+1;
            }
        } else {
            $weight = 1;
        }
    
        // Get next ID in table - this is required prior to any insert that
        // uses a unique ID, and ensures that the ID generation is carried
        // out in a database-portable fashion
        $nextId = $dbconn->GenId($contentitems_table);
    
        // Add content item - the formatting here is not mandatory, but it does make
        // the SQL statement relatively easy to read.  Also, separating out
        // the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql = "INSERT INTO $contentitems_table (
                  $contentitems_column[id],
                  $contentitems_column[parent_id],
                  $contentitems_column[cat_id],
                  $contentitems_column[language],
                  $contentitems_column[title],
                  $contentitems_column[title_align],
                  $contentitems_column[text],
                  $contentitems_column[enable_title],
                  $contentitems_column[media_url],
                  $contentitems_column[media_width],
                  $contentitems_column[media_height],
                  $contentitems_column[media_text],
                  $contentitems_column[layout_id],
                  $contentitems_column[start_date],
                  $contentitems_column[end_date],
                  $contentitems_column[top_print],
                  $contentitems_column[bottom_print],
                  $contentitems_column[status],
                  $contentitems_column[weight],
                  $contentitems_column[navigation],
                  $contentitems_column[top_sendfriend],
                  $contentitems_column[bottom_sendfriend],
                  $contentitems_column[backgroundcolor],
                  $contentitems_column[last_updated],
                  $contentitems_column[times_read],
                  $contentitems_column[show_last_updated],
                  $contentitems_column[show_times_read],
                  $contentitems_column[author],
                  $contentitems_column[notes]
                  )
                VALUES (
                  $nextId,
                  " . pnVarPrepForStore($parent_id) . ",
                  " . pnVarPrepForStore($cat_id) . ",
                  '" . pnVarPrepForStore($language) . "',
                  '" . pnVarPrepForStore($title) . "',
                  " . pnVarPrepForStore($title_align) . ",
                  '" . pnVarPrepForStore($text) . "',
                  " . pnVarPrepForStore($enable_title) . ",
                  '" . pnVarPrepForStore($media_url) . "',
                  " . pnVarPrepForStore($media_width) . ",
                  " . pnVarPrepForStore($media_height) . ",
                  '" . pnVarPrepForStore($media_text) . "',
                  " . pnVarPrepForStore($layout_id) . ",
                  '" . pnVarPrepForStore($start_date) . "',
                  '" . pnVarPrepForStore($end_date) . "',
                  " . pnVarPrepForStore($top_print) . ",
                  " . pnVarPrepForStore($bottom_print) . ",
                  " . pnVarPrepForStore($status) . ",
                  " . pnVarPrepForStore($weight) . ",
                  " . pnVarPrepForStore($navigation) . ",
                  " . pnVarPrepForStore($top_sendfriend) . ",
                  " . pnvarPrepForStore($bottom_sendfriend) . ",
                  '" . pnVarPrepForStore($backgroundcolor) . "',
                  '" . pnVarPrepForStore($last_updated) . "',
                  '" . pnVarPrepForStore($times_read) . "',
                  " . pnVarPrepForStore($show_last_updated) . ",
                  " . pnVarPrepForStore($show_times_read) . ",
                  '" .pnVarPrepForStore($author)."',
                  '" .pnVarPrepForStore($notes)."')";
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _CREATEFAILED);
            return false;
        }
    
        // Get the ID of the item that we inserted.  It is possible, although
        // very unlikely, that this is different from $nextId as obtained
        // above, but it is better to be safe than sorry in this situation
        $id = $dbconn->PO_Insert_ID($contentitems_table, $contentitems_column['id']);
    
        if( strcmp( $upld_media, "none" ) != 0 &&
            strcmp( $upld_media, "" ) != 0 ) {
            // It's good practice to name the table and column definitions you
            // are getting - $table and $column don't cut it in more complex
            // modules
            $mediaitems_table = $pntable['mme_mediaitems'];
            $mediaitems_column = &$pntable['mme_mediaitems_column'];
        
            // Get next ID in table - this is required prior to any insert that
            // uses a unique ID, and ensures that the ID generation is carried
            // out in a database-portable fashion
            $nextId = $dbconn->GenId($mediaitems_table);
        
            // Add media item - the formatting here is not mandatory, but it does make
            // the SQL statement relatively easy to read.  Also, separating out
            // the sql statement from the Execute() command allows for simpler
            // debug operation if it is ever needed
            $sql = "INSERT INTO $mediaitems_table (
                      $mediaitems_column[id],
                      $mediaitems_column[filename],
                      $mediaitems_column[filesize],
                      $mediaitems_column[mimetype])
                    VALUES (
                      $nextId,
                      '" . pnVarPrepForStore($media_url) . "',
                      " . pnVarPrepForStore($upld_media_size) . ",
                      '" . pnVarPrepForStore($media_type) . "')";
            $dbconn->Execute($sql);
        
            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _MENUCONTENTMEDIADUPLICATE);
                return false;
            }
        }
    
        // Let any hooks know that we have created a new item.  As this is a
        // create hook we're passing 'ceid' as the extra info, which is the
        // argument that all of the other functions use to reference this
        // item
        pnModCallHooks('item', 'create', $id, 'ceid');
    
        // Return the id of the newly created item to the calling process
        return $id;
    }

    // Administrative API helper methods
    // API delete
    function api_delete( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if (!isset($ceid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_contentitem',
                array('ceid' => $ceid));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$ceid", ACCESS_DELETE)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
    
        // Need to check to see if this content item has any children, if so, need to
        // shift them one level up so it won't become orphanage.
        $sql = "UPDATE $contentitems_table
                SET $contentitems_column[parent_id] = " . pnVarPrepForStore($item['parent_id']) . "
                WHERE $contentitems_column[parent_id] = " . pnVarPrepForStore($ceid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _DELETEFAILED);
            return false;
        }
    
        // Delete the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql = "DELETE FROM $contentitems_table
                WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _DELETEFAILED);
            return false;
        }
    
        // Remove image file previously attach to this content to save space.
        $enable_aclean = pnModGetVar('ContentExpress', 'enable_aclean');
        if( $enable_aclean ) {
            $sql = "SELECT COUNT(*)
                    FROM $contentitems_table
                    WHERE $contentitems_column[media_url] = '". $item['media_url'] ."'";
            $result = $dbconn->Execute($sql);
    
            if( $result != false ) {
                list( $ref_count ) = $result->fields;
                if( empty( $ref_count ) || $ref_count == 0 ) {
                    if( strlen( $item['media_url'] ) > 0 && 
                        unlink( "modules/ContentExpress/".$item['media_url'] )) {
                        // It's good practice to name the table and column definitions you
                        // are getting - $table and $column don't cut it in more complex
                        // modules
                        $mediaitems_table = $pntable['mme_mediaitems'];
                        $mediaitems_column = &$pntable['mme_mediaitems_column'];
    
                        // Update/Add media item - the formatting here is not mandatory, but it does make
                        // the SQL statement relatively easy to read.  Also, separating out
                        // the sql statement from the Execute() command allows for simpler
                        // debug operation if it is ever needed
                        $sql = "DELETE FROM $mediaitems_table
                                WHERE $mediaitems_column[filename] = '" . $item['media_url'] . "'";
                        $dbconn->Execute($sql);

                        // Check for an error with the database code, and if so set an
                        // appropriate error message and return
                        if ($dbconn->ErrorNo() != 0) {
                            pnSessionSetVar('errormsg', _UPDATEFAILED);
                            return false;
                        }
                    }
                }
            }
        }
    
        // Let any hooks know that we have deleted an item.  As this is a
        // delete hook we're not passing any extra info
        pnModCallHooks('item', 'delete', $ceid, '');
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    // Administrative API helper methods
    // API update
    function api_update( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($ceid)) || (!isset($parent_id)) || (!isset($cat_id)) ||
            (!isset($language)) || (!isset($title)) || (!isset($title_align)) || (!isset($text)) ||
            (!isset($status)) || (!isset($weight))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if( empty($enable_title)) { $enable_title = 0; }
        if( empty($media_url)) { $media_url = ""; }
        if( empty($media_width)) { $media_width = 0; }
        if( empty($media_height)) { $media_height = 0; }
        if( empty($media_text)) { $media_text = ""; }
        if( empty($layout_id)) { $layout_id = 1; }
        if( empty($upld_media)) { $upld_media = ""; }
        if( empty($upld_media_name)) { $upld_media_name = ""; }
        if( empty($upld_media_type)) { $upld_media_type = ""; }
        if( empty($upld_media_size)) { $upld_media_size = 0; }
        if( empty($top_print)) { $top_print = 0; }
        if( empty($bottom_print)) { $bottom_print = 0; }
        if( empty($start_date)) { $start_date = strftime( "%Y-%m-%d %H:%M:%S", time()); }
        // This is the approx. last date that 32-bit value can handle
        if( empty($end_date)) { $end_date = "2038-01-18 00:00:00"; }
        if( empty($navigation)) { $navigation = 0; }
        if( empty($top_sendfriend)) { $top_sendfriend = 0; }
        if( empty($bottom_sendfriend)) { $bottom_sendfriend = 0; }
        if( empty($backgroundcolor)) { $backgroundcolor = ''; }
        if( empty($last_updated)) { $last_updated = strftime( "%Y-%m-%d %H:%M:%S", time()); }
        if( empty($times_read)) { $times_read = 1; }
        if( empty($show_last_updated)) { $show_last_updated = 0; }
        if( empty($show_times_read)) { $show_times_read = 0; }
        if( empty($author)) { $author = pnUserGetVar('name'); }
        if( empty($notes)) { $notes = ""; }

        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }

        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_contentitem',
                array('ceid' => $ceid ));

        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }

        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$ceid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$title:$ceid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Move the media file to designate directory 
        if( strcmp( $upld_media, "none" ) != 0 &&
            strcmp( $upld_media, "" ) != 0 ) {
    
            // Verify the media file type if appropriate
            $media_types = pnModGetVar( 'MediaExpress', 'media_types' );
            if ( strlen($upld_media_name) > 0 &&
                 strlen($upld_media_type) > 0 &&
                 substr_count($media_types,$upld_media_type) <= 0 ) {
                pnSessionSetVar('errormsg', _MENUCONTENTBADIMGTYPE);
                return false;
            }
    
            // Verify the size of the media file
            $max_media_size = pnModGetVar( 'MediaExpress', 'max_media_size' );
            if( strlen($upld_media_name) > 0 && $max_media_size < $upld_media_size ) {
                pnSessionSetVar('errormsg', _MENUCONTENTIMGTOOBIG);
                return false;
            }
    
            $media_repository = pnModGetVar( 'MediaExpress', 'media_repository' );
            if( is_uploaded_file( $upld_media )) {
                if( !move_uploaded_file( $upld_media, "modules/ContentExpress/".$media_repository."/".$upld_media_name )) {
                    pnSessionSetVar('errormsg', _MENUCONTENTIMGCOPYFAILED);
                    return false;
                }
                // bug fix provided by pini, many thanks!!
                chmod("modules/ContentExpress/$media_repository/$upld_media_name", 0644);
            }
    
            // Update the media url in the content
            $media_url = $media_repository."/".$upld_media_name;
            $media_type = $upld_media_type;
        }

        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];

        $sql =  "UPDATE $contentitems_table ";
        $sql .= "SET $contentitems_column[parent_id] = " . pnVarPrepForStore($parent_id) . ", ";
        $sql .= "$contentitems_column[cat_id] = " . pnVarPrepForStore($cat_id) . ", ";
        $sql .= "$contentitems_column[language] = '" . pnVarPrepForStore($language) . "', ";
        $sql .= "$contentitems_column[title] = '" . pnVarPrepForStore($title) . "', ";
        $sql .= "$contentitems_column[title_align] = " . pnVarPrepForStore($title_align) . ", ";
        $sql .= "$contentitems_column[text] = '" . pnVarPrepForStore($text) . "', ";
        $sql .= "$contentitems_column[enable_title] = " . pnVarPrepForStore($enable_title) . ", ";
        $sql .= "$contentitems_column[media_url] = '" . pnVarPrepForStore($media_url) . "', ";
        $sql .= "$contentitems_column[media_width] = '" . pnVarPrepForStore($media_width) . "', ";
        $sql .= "$contentitems_column[media_height] = '" . pnVarPrepForStore($media_height) . "', ";
        $sql .= "$contentitems_column[media_text] = '" . pnVarPrepForStore($media_text) . "', ";
        $sql .= "$contentitems_column[layout_id] = " . pnVarPrepForStore($layout_id) . ", ";
        $sql .= "$contentitems_column[start_date] = '" . pnVarPrepForStore($start_date) . "', ";
        $sql .= "$contentitems_column[end_date] = '" . pnVarPrepForStore($end_date) . "', ";
        $sql .= "$contentitems_column[top_print] = " . pnVarPrepForStore($top_print) . ", ";
        $sql .= "$contentitems_column[bottom_print] = " . pnVarPrepForStore($bottom_print) . ", ";
        $sql .= "$contentitems_column[status] = " . pnVarPrepForStore($status) . ", ";
        $sql .= "$contentitems_column[weight] = " . pnVarPrepForStore($weight) . ", ";
        $sql .= "$contentitems_column[navigation] = " . pnVarPrepForStore($navigation) . ", ";
        $sql .= "$contentitems_column[top_sendfriend] = " . pnVarPrepForStore($top_sendfriend) . ", ";
        $sql .= "$contentitems_column[bottom_sendfriend] = " . pnVarPrepForStore($bottom_sendfriend) . ", ";
        $sql .= "$contentitems_column[backgroundcolor] = '" . pnVarPrepForStore($backgroundcolor) . "', ";
        $sql .= "$contentitems_column[last_updated] = '" . pnVarPrepForStore($last_updated) . "', ";
        $sql .= "$contentitems_column[times_read] = '" . pnVarPrepForStore($times_read) . "', ";
        $sql .= "$contentitems_column[show_last_updated] = '" . pnVarPrepForStore($show_last_updated) . "', ";
        $sql .= "$contentitems_column[show_times_read] = '" . pnVarPrepForStore($show_times_read) . "', ";
        $sql .= "$contentitems_column[author] = '" . pnVarPrepForStore($author) . "', ";
        $sql .= "$contentitems_column[notes] = '" . pnVarPrepForStore($notes) . "' ";
        $sql .= "WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);

        $dbconn->Execute($sql);

        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }

        if( strcmp( $upld_media, "none" ) != 0 &&
            strcmp( $upld_media, "" ) != 0 ) {
            // It's good practice to name the table and column definitions you
            // are getting - $table and $column don't cut it in more complex
            // modules
            $mediaitems_table = $pntable['mme_mediaitems'];
            $mediaitems_column = &$pntable['mme_mediaitems_column'];

            // Update/Add media item - the formatting here is not mandatory, but it does make
            // the SQL statement relatively easy to read.  Also, separating out
            // the sql statement from the Execute() command allows for simpler
            // debug operation if it is ever needed
            $sql = "UPDATE $mediaitems_table
                    SET $mediaitems_column[filesize] = " . pnVarPrepForStore($upld_media_size) . ",
                        $mediaitems_column[mimetype] = '" . pnVarPrepForStore($media_type) . "'
                    WHERE $mediaitems_column[filename] = '" . pnVarPrepForStore($media_url) . "')";
            $dbconn->Execute($sql);

            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                // Get next ID in table - this is required prior to any insert that
                // uses a unique ID, and ensures that the ID generation is carried
                // out in a database-portable fashion
                $nextId = $dbconn->GenId($mediaitems_table);

                $sql = "INSERT INTO $mediaitems_table (
                          $mediaitems_column[id],
                          $mediaitems_column[filename],
                          $mediaitems_column[filesize],
                          $mediaitems_column[mimetype])
                        VALUES (
                          $nextId,
                          '" . pnVarPrepForStore($media_url) . "',
                          " . pnVarPrepForStore($upld_media_size) . ",
                          '" . pnVarPrepForStore($media_type) . "')";
                $dbconn->Execute($sql);

                // Check for an error with the database code, and if so set an
                // appropriate error message and return
                if ($dbconn->ErrorNo() != 0) {
                    pnSessionSetVar('errormsg', _MENUCONTENTMEDIADUPLICATE);
                    return false;
                }
            }
        }

        // Remove image file previously attach to this content to save space.
        $enable_aclean = pnModGetVar('ContentExpress', 'enable_aclean');
        if( $enable_aclean ) {
            $sql = "SELECT COUNT(*)
                    FROM $contentitems_table
                    WHERE $contentitems_column[media_url] = '". $item['media_url'] ."'";
            $result = $dbconn->Execute($sql);

            if( $result != false ) {
                list( $ref_count ) = $result->fields;
                if( empty( $ref_count ) || $ref_count == 0 ) {
                    if( strlen( $item['media_url'] ) > 0 &&
                        unlink( "modules/ContentExpress/".$item['media_url'] )) {
                        // It's good practice to name the table and column definitions you
                        // are getting - $table and $column don't cut it in more complex
                        // modules
                        $mediaitems_table = $pntable['mme_mediaitems'];
                        $mediaitems_column = &$pntable['mme_mediaitems_column'];

                        // Update/Add media item - the formatting here is not mandatory, but it does make
                        // the SQL statement relatively easy to read.  Also, separating out
                        // the sql statement from the Execute() command allows for simpler
                        // debug operation if it is ever needed
                        $sql = "DELETE FROM $mediaitems_table
                                WHERE $mediaitems_column[filename] = '" . $item['media_url'] . "'";
                        $dbconn->Execute($sql);

                        // Check for an error with the database code, and if so set an
                        // appropriate error message and return
                        if ($dbconn->ErrorNo() != 0) {
                            pnSessionSetVar('errormsg', _UPDATEFAILED);
                            return false;
                        }
                    }
                }
            }
        }

        // Let the calling process know that we have finished successfully
        return true;
    }

    // Administrative API helper methods
    // API quick update
    function api_qupdate( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other
        // places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present,
        // if not then set an appropriate error message and return
        if ((!isset($ceid)) || (!isset($task))) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        if( empty( $pid )) { $pid = -1; }
    
        // Load API.  Note that this is loading the user API in addition to
        // the administration API, that is because the user API contains
        // the function to obtain item information which is the first thing
        // that we need to do.  If the API fails to load an appropriate error
        // message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return false;
        }
    
        // The user API function is called.  This takes the item ID which
        // we obtained from the input and gets us the information on the
        // appropriate item.  If the item does not exist we post an appropriate
        // message and return
        $item = pnModAPIFunc('ContentExpress',
                'user',
                'get_contentitem',
                array('ceid' => $ceid ));
    
        if ($item == false) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
    
        $pitem = false;
        if( $pid > 0 ) {
            $pitem = pnModAPIFunc('ContentExpress',
                                  'user',
                                  'get_contentitem',
                                  array('ceid' => $pid ));
            if( $pitem == false ) {
                pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
                return false;
            }
        }
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing.
        // However, in this case we had to wait until we could obtain the item
        // name to complete the instance information so this is the first
        // chance we get to do the check
    
        // Note that at this stage we have two sets of item information, the
        // pre-modification and the post-modification.  We need to check against
        // both of these to ensure that whoever is doing the modification has
        // suitable permissions to edit the item otherwise people can potentially
        // edit areas to which they do not have suitable access
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$ceid", ACCESS_EDIT)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOAUTH);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn()
        // we currently just want the first item, which is the official
        // database handle.  For pnDBGetTables() we want to keep the entire
        // tables array together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you
        // are getting - $table and $column don't cut it in more complex
        // modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
    
        $menuitems_table = $pntable['ce_menuitems'];
        $menuitems_column = &$pntable['ce_menuitems_column'];
    
        // Update the item - the formatting here is not mandatory, but it does
        // make the SQL statement relatively easy to read.  Also, separating
        // out the sql statement from the Execute() command allows for simpler
        // debug operation if it is ever needed
        $sql = "";
        if( $task == 'left' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "content", $task, $ceid, $pid );
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[parent_id] = '" . pnVarPrepForStore($pitem['parent_id']) . "',
                        $contentitems_column[weight] = '" . pnVarPrepForStore($weight1) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);
        }
        else if( $task == 'right' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "content", $task, $ceid, $pid );
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[parent_id] = '" . pnVarPrepForStore($pid) . "',
                        $contentitems_column[weight] = '" . pnVarPrepForStore($weight1) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);
        }
        else if( $task == 'up' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "content", $task, $ceid, $pid );
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[weight] = '" . pnVarPrepForStore($weight1) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);

            $dbconn->Execute($sql);
    
            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _UPDATEFAILED);
                return false;
            }
    
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[weight] = '" . pnVarPrepForStore($weight2) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($pid);
        }
        else if( $task == 'down' ) {
            list($weight1,$weight2) = CommonExpress_calculate_weight( $dbconn, $pntable, "content", $task, $ceid, $pid );
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[weight] = '" . pnVarPrepForStore($weight2) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);

            $dbconn->Execute($sql);
    
            // Check for an error with the database code, and if so set an
            // appropriate error message and return
            if ($dbconn->ErrorNo() != 0) {
                pnSessionSetVar('errormsg', _UPDATEFAILED);
                return false;
            }
    
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[weight] = '" . pnVarPrepForStore($weight1) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($pid);
        }
        else if( $task == 'act' ) {
            $status = 2;
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[status] = '" . pnVarPrepForStore($status) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);
        }
        else if( $task == 'deact' ) {
            $status = 1;
            $sql = "UPDATE $contentitems_table
                    SET $contentitems_column[status] = '" . pnVarPrepForStore($status) . "'
                    WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid);
        } else {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an
        // appropriate error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _UPDATEFAILED);
            return false;
        }
    
        // Let the calling process know that we have finished successfully
        return true;
    }

    // User API helper method
    // This method retreive all the content item for the current
    // language setting
    function api_getall( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        //$debug = new debugHelper();
        extract($args);

        $items = array();

        // Security check - important to do this as early on as possible to
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_READ)) {
            return false;
        }

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $currlang = pnUserGetLang();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
        $mediaitems_table = $pntable['mme_mediaitems'];
        $mediaitems_column = &$pntable['mme_mediaitems_column'];
    
        // Get items - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the SelectLimit() command allows for simpler debug
        // operation if it is ever needed
        $sql = "SELECT $contentitems_column[id],
                       $contentitems_column[parent_id],
                       $contentitems_column[cat_id],
                       $categories_column[title] as category,
                       $contentitems_column[language],
                       $contentitems_column[title],
                       $contentitems_column[title_align],
                       $contentitems_column[enable_title],
                       $contentitems_column[media_url],
                       $mediaitems_column[mimetype],
                       $contentitems_column[media_width],
                       $contentitems_column[media_height],
                       $contentitems_column[media_text],
                       $contentitems_column[layout_id],
                       $contentitems_column[start_date],
                       $contentitems_column[end_date],
                       $contentitems_column[top_print],
                       $contentitems_column[bottom_print],
                       $contentitems_column[status],
                       $contentitems_column[weight],
                       $contentitems_column[navigation],
                       $contentitems_column[top_sendfriend],
                       $contentitems_column[bottom_sendfriend],
                       $contentitems_column[backgroundcolor],
                       $contentitems_column[last_updated],
                       $contentitems_column[times_read],
                       $contentitems_column[show_last_updated],
                       $contentitems_column[show_times_read],
                       $contentitems_column[author],
                       $contentitems_column[notes]
                FROM $contentitems_table, $mediaitems_table, $categories_table
                WHERE  $contentitems_column[media_url] = $mediaitems_column[filename] AND
                       $contentitems_column[cat_id] = $categories_column[id] ";

        // If current date is provided, then use it to restrict result set
        if( $modulemode <> 'admin' ){
            $sql .= "AND ($contentitems_column[language] = '" . pnVarPrepForStore($currlang) . "' OR
                       $contentitems_column[language] = 'x_all') ";
        }
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= "AND $contentitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."' ".
                    "AND '".pnVarPrepForStore($curr_date)."' <= $contentitems_column[end_date] ";
        }

        // If current status is provided, then use it to restrict result set
        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= "AND $contentitems_column[status] = ".pnVarPrepForStore($curr_status)." ";
        }

        $sql .= "ORDER BY $contentitems_column[parent_id],";

        if( isset( $cat_id ) && !empty( $cat_id )) {
            $sql .= "         $categories_column[title],";
        }

        $sql .= "         $contentitems_column[weight]";

        $result = $dbconn->Execute($sql);

        if( $result ) {

            // Check for an error with the database code, and if so set an appropriate
            // error message and return
            if ($dbconn->ErrorNo() != 0 ) {
                pnSessionSetVar('errormsg', _GETFAILED);
                return false;
            }

            // Put items into result array.  Note that each item is checked
            // individually to ensure that the user is allowed access to it before it
            // is added to the results array
            for (; !$result->EOF; $result->MoveNext()) {
                list($id, $parent_id, $cat_id, $category, $language, $title, $title_align, $enable_title,
                     $media_url, $media_type, $media_width, $media_height, $media_text,
                     $layout_id, $start_date, $end_date, $top_print, $bottom_print,
                     $status, $weight, $navigation, $top_sendfriend, $bottom_sendfriend,
                     $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
                     $author, $notes) = $result->fields;
                if( pnSecAuthAction(0, 'ContentExpress::Content', ":$title:$id", ACCESS_READ )) {
                    $items[] = array('id' => $id,
                                     'parent_id' => $parent_id,
                                     'cat_id' => $cat_id,
                                     'category' => $category,
                                     'language' => $language,
                                     'title' => $title,
                                     'title_align' => $title_align,
                                     'enable_title' => $enable_title,
                                     'media_url' => $media_url,
                                     'media_type' => $media_type,
                                     'media_width' => $media_width,
                                     'media_height' => $media_height,
                                     'media_text' => $media_text,
                                     'layout_id' => $layout_id,
                                     'start_date' => $start_date,
                                     'end_date' => $end_date,
                                     'top_print' => $top_print,
                                     'bottom_print' => $bottom_print,
                                     'status' => $status,
                                     'weight' => $weight,
                                     'navigation' => $navigation,
                                     'top_sendfriend' => $top_sendfriend,
                                     'bottom_sendfriend' => $bottom_sendfriend,
                                     'backgroundcolor' => $backgroundcolor,
                                     'last_updated' => $last_updated,
                                     'times_read' => $times_read,
                                     'show_last_updated' => $show_last_updated,
                                     'show_times_read' => $show_times_read,
                                     'author' => $author,
                                     'notes' => $notes);
                }
            }
    
            // All successful database queries produce a result set, and that result
            // set should be closed when it has been finished with
            $result->Close();
        }
    
        // Return the items
        return $items;
    }

    // User API helper method
    // This method retreive content item for the given ceid
    function api_get( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($ceid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $categories_table = $pntable['ce_categories'];
        $categories_column = &$pntable['ce_categories_column'];
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
        $mediaitems_table = $pntable['mme_mediaitems'];
        $mediaitems_column = &$pntable['mme_mediaitems_column'];
    
        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql = "SELECT $contentitems_column[parent_id],
                       $contentitems_column[cat_id],
                       $categories_column[title] as category,
                       $contentitems_column[language],
                       $contentitems_column[title],
                       $contentitems_column[title_align],
                       $contentitems_column[text],
                       $contentitems_column[enable_title],
                       $contentitems_column[media_url],
                       $mediaitems_column[mimetype],
                       $contentitems_column[media_width],
                       $contentitems_column[media_height],
                       $contentitems_column[media_text],
                       $contentitems_column[layout_id],
                       $contentitems_column[start_date],
                       $contentitems_column[end_date],
                       $contentitems_column[top_print],
                       $contentitems_column[bottom_print],
                       $contentitems_column[status],
                       $contentitems_column[weight],
                       $contentitems_column[navigation],
                       $contentitems_column[top_sendfriend],
                       $contentitems_column[bottom_sendfriend],
                       $contentitems_column[backgroundcolor],
                       $contentitems_column[last_updated],
                       $contentitems_column[times_read],
                       $contentitems_column[show_last_updated],
                       $contentitems_column[show_times_read],
                       $contentitems_column[author],
                       $contentitems_column[notes]
                FROM $contentitems_table, $mediaitems_table, $categories_table
                WHERE $contentitems_column[id] = " . pnVarPrepForStore($ceid) . " AND
                      $contentitems_column[media_url] = $mediaitems_column[filename] AND
                      $contentitems_column[cat_id] = $categories_column[id] ";


        // If current date is provided, then use it to restrict result set
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= "AND $contentitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."' ".
                    "AND '".pnVarPrepForStore($curr_date)."' <= $contentitems_column[end_date] ";
        }

        // If current status is provided, then use it to restrict result set
        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= "AND $contentitems_column[status] = ".pnVarPrepForStore($curr_status)." ";
        }

        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
    
        // Check for no rows found, and if so return
        if ($result->EOF) {
            return false;
        }
    
        // Obtain the item information from the result set
        list($parent_id, $cat_id, $category, $language, $title, $title_align, $text, $enable_title,
        $media_url, $media_type, $media_width, $media_height, $media_text, $layout_id,
        $start_date, $end_date, $top_print, $bottom_print,
        $status, $weight, $navigation, $top_sendfriend, $bottom_sendfriend,
        $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
        $author, $notes) = $result->fields;
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Security check - important to do this as early on as possible to avoid
        // potential security holes or just too much wasted processing.  Although
        // this one is a bit late in the function it is as early as we can do it as
        // this is the first time we have the relevant information
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$title:$ceid", ACCESS_READ)) {
            return false;
        }
    
        // Create the item array
        $item = array('id' => $ceid,
                      'parent_id' => $parent_id,
                      'cat_id' => $cat_id,
                      'category' => $category,
                      'language' => $language,
                      'title' => $title,
                      'title_align' => $title_align,
                      'text' => $text,
                      'enable_title' => $enable_title,
                      'media_url' => $media_url,
                      'media_type' => $media_type,
                      'media_width' => $media_width,
                      'media_height' => $media_height,
                      'media_text' => $media_text,
                      'layout_id' => $layout_id,
                      'start_date' => $start_date,
                      'end_date' => $end_date,
                      'top_print' => $top_print,
                      'bottom_print' => $bottom_print,
                      'status' => $status,
                      'weight' => $weight,
                      'navigation' => $navigation,
                      'top_sendfriend' => $top_sendfriend,
                      'bottom_sendfriend' => $bottom_sendfriend,
                      'backgroundcolor' => $backgroundcolor,
                      'last_updated' => $last_updated,
                      'times_read' => $times_read,
                      'show_last_updated' => $show_last_updated,
                      'show_times_read' => $show_times_read,
                      'author' => $author,
                      'notes' => $notes);
    
        // Return the item array
        return $item;
    }

    // User API helper method
    // This method retreive content item for the given category id
    function api_getbycatid( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($cecatid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
        $mediaitems_table = $pntable['mme_mediaitems'];
        $mediaitems_column = &$pntable['mme_mediaitems_column'];
    
        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql = "SELECT $contentitems_column[id],
                       $contentitems_column[parent_id],
                       $contentitems_column[cat_id],
                       $contentitems_column[language],
                       $contentitems_column[title],
                       $contentitems_column[title_align],
                       $contentitems_column[text],
                       $contentitems_column[enable_title],
                       $contentitems_column[media_url],
                       $mediaitems_column[mimetype],
                       $contentitems_column[media_width],
                       $contentitems_column[media_height],
                       $contentitems_column[media_text],
                       $contentitems_column[layout_id],
                       $contentitems_column[start_date],
                       $contentitems_column[end_date],
                       $contentitems_column[top_print],
                       $contentitems_column[bottom_print],
                       $contentitems_column[status],
                       $contentitems_column[weight],
                       $contentitems_column[navigation],
                       $contentitems_column[top_sendfriend],
                       $contentitems_column[bottom_sendfriend],
                       $contentitems_column[backgroundcolor],
                       $contentitems_column[last_updated],
                       $contentitems_column[times_read],
                       $contentitems_column[show_last_updated],
                       $contentitems_column[show_times_read],
                       $contentitems_column[author],
                       $contentitems_column[notes]
                FROM $contentitems_table, $mediaitems_table
                WHERE $contentitems_column[cat_id] = " . pnVarPrepForStore($cecatid) . " AND
                      $contentitems_column[media_url] = $mediaitems_column[filename]";

        // If current date is provided, then use it to restrict result set
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= " AND $contentitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."' 
                      AND '".pnVarPrepForStore($curr_date)."' <= $contentitems_column[end_date]";
        }

        // If current date is provided, then use it to restrict result set
        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= " AND $contentitems_column[status] = ".pnVarPrepForStore($curr_status);
        }
        $sql .= " ORDER BY $contentitems_column[title],
                           $contentitems_column[start_date],
                           $contentitems_column[weight]";

        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
    
        // Check for no rows found, and if so return
        if ($result->EOF) {
            return false;
        }
    
        // Obtain the item information from the result set
        list($parent_id, $cat_id, $category, $language, $title, $title_align, $text, $enable_title,
        $media_url, $media_type, $media_width, $media_height, $media_text, $layout_id,
        $start_date, $end_date, $top_print, $bottom_print,
        $status, $weight, $navigation, $top_sendfriend, $bottom_sendfriend,
        $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
        $author, $notes) = $result->fields;

        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Security check - important to do this as early on as possible to avoid
        // potential security holes or just too much wasted processing.  Although
        // this one is a bit late in the function it is as early as we can do it as
        // this is the first time we have the relevant information
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$title:$id", ACCESS_READ)) {
            return false;
        }
    
        // Create the item array
        $item = array('id' => $id,
                      'parent_id' => $parent_id,
                      'cat_id' => $cat_id,
                      'category' => $category,
                      'language' => $language,
                      'title' => $title,
                      'title_align' => $title_align,
                      'text' => $text,
                      'enable_title' => $enable_title,
                      'media_url' => $media_url,
                      'media_type' => $media_type,
                      'media_width' => $media_width,
                      'media_height' => $media_height,
                      'media_text' => $media_text,
                      'layout_id' => $layout_id,
                      'start_date' => $start_date,
                      'end_date' => $end_date,
                      'top_print' => $top_print,
                      'bottom_print' => $bottom_print,
                      'status' => $status,
                      'weight' => $weight,
                      'navigation' => $navigation,
                      'top_sendfriend' => $top_sendfriend,
                      'bottom_sendfriend' => $bottom_sendfriend,
                      'backgroundcolor' => $backgroundcolor,
                      'last_updated' => $last_updated,
                      'times_read' => $times_read,
                      'show_last_updated' => $show_last_updated,
                      'show_times_read' => $show_times_read,
                      'author' => $author,
                      'notes' => $notes);
    
        // Return the item array
        return $item;
    }

    function api_getallchild( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);

        // Argument check - make sure that all required arguments are present, if
        // not then set an appropriate error message and return
        if (!isset($ceid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }

        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $currlang = pnUserGetLang();

        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
        $mediaitems_table = $pntable['mme_mediaitems'];
        $mediaitems_column = &$pntable['mme_mediaitems_column'];

        // Get item - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the Execute() command allows for simpler debug operation
        // if it is ever needed
        $sql = "SELECT $contentitems_column[id],
                       $contentitems_column[parent_id],
                       $contentitems_column[cat_id],
                       $contentitems_column[language],
                       $contentitems_column[title],
                       $contentitems_column[title_align],
                       $contentitems_column[text],
                       $contentitems_column[enable_title],
                       $contentitems_column[media_url],
                       $mediaitems_column[mimetype],
                       $contentitems_column[media_width],
                       $contentitems_column[media_height],
                       $contentitems_column[media_text],
                       $contentitems_column[layout_id],
                       $contentitems_column[start_date],
                       $contentitems_column[end_date],
                       $contentitems_column[top_print],
                       $contentitems_column[bottom_print],
                       $contentitems_column[status],
                       $contentitems_column[weight],
                       $contentitems_column[navigation],
                       $contentitems_column[top_sendfriend],
                       $contentitems_column[bottom_sendfriend],
                       $contentitems_column[backgroundcolor],
                       $contentitems_column[last_updated],
                       $contentitems_column[times_read],
                       $contentitems_column[show_last_updated],
                       $contentitems_column[show_times_read],
                       $contentitems_column[author],
                       $contentitems_column[notes]
                FROM $contentitems_table, $mediaitems_table
                WHERE $contentitems_column[parent_id] = " . pnVarPrepForStore($ceid) . " AND
                      ( $contentitems_column[media_url] = $mediaitems_column[filename] OR
                        $contentitems_column[media_url] = 'none' OR
                        $contentitems_column[media_url] = '' )";

        if( $modulemode <> "admin"){
            $sql .= "AND ($contentitems_column[language] = '" . pnVarPrepForStore($currlang) . "' OR
                       $contentitems_column[language] = 'x_all') ";
        }
        // If current date is provided, then use it to restrict result set
        if( isset( $curr_date ) && !empty( $curr_date )) {
            $sql .= "AND $contentitems_column[start_date] <= '".pnVarPrepForStore($curr_date)."'
                     AND '".pnVarPrepForStore($curr_date)."' <= $contentitems_column[end_date] ";
        }

        if( isset( $curr_status ) && !empty( $curr_status )) {
            $sql .= "AND $contentitems_column[status] = ".pnVarPrepForStore($curr_status)." ";
        }

        $sql .= "ORDER BY $contentitems_column[weight]";
        $result = $dbconn->Execute($sql);

        $items = array();

        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }

        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $parent_id, $cat_id, $language, $title, $title_align, $text,
                 $enable_title, $media_url, $media_type, $media_width,
                 $media_height, $media_text, $layout_id, $start_date, $end_date,
                 $top_print, $bottom_print, $status, $weight,
                 $navigation, $top_sendfriend, $bottom_sendfriend,
                 $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
                 $author, $notes) = $result->fields;
            if( pnSecAuthAction( 0, "ContentExpress::Content", ":$title:$id", ACCESS_READ )) {
                $items[$id] = array(
                                 'id' => $id,
                                 'parent_id' => $parent_id,
                                 'cat_id' => $cat_id,
                                 'language' => $language,
                                 'title' => $title,
                                 'title_align' => $title_align,
                                 'text' => $text,
                                 'enable_title' => $enable_title,
                                 'media_url' => $media_url,
                                 'media_type' => $media_type,
                                 'media_width' => $media_width,
                                 'media_height' => $media_height,
                                 'media_text' => $media_text,
                                 'layout_id' => $layout_id,
                                 'start_date' => $start_date,
                                 'end_date' => $end_date,
                                 'top_print' => $top_print,
                                 'bottom_print' => $bottom_print,
                                 'status' => $status,
                                 'weight' => $weight,
                                 'navigation' => $navigation,
                                 'top_sendfriend' => $top_sendfriend,
                                 'bottom_sendfriend' => $bottom_sendfriend,
                                 'backgroundcolor' => $backgroundcolor,
                                 'last_updated' => $last_updated,
                                 'times_read' => $times_read,
                                 'show_last_updated' => $show_last_updated,
                                 'show_times_read' => $show_times_read,
                                 'author' => $author,
                                 'notes' => $notes);
            }
        }

        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();

        // Return the item array
        return $items;
    }

    function api_getlayouts( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        $items = array();
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_READ)) {
            return $items;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
    
        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $layouts_table = $pntable['ce_layout'];
        $layouts_column = &$pntable['ce_layout_column'];
    
        // Get items - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the SelectLimit() command allows for simpler debug
        // operation if it is ever needed
        $sql = "SELECT $layouts_column[id],
                       $layouts_column[name],
                       $layouts_column[description],
                       $layouts_column[text]
                FROM $layouts_table
                ORDER BY $layouts_column[id]";
        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _GETFAILED);
            return false;
        }
    
        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $name, $description, $text) = $result->fields;
            if (pnSecAuthAction(0, 'ContentExpress::Layout', "$name::$id", ACCESS_READ)) {
                $items[] = array('id' => $id,
                                 'parent_id' => -1,
                                 'title' => $name,
                                 'description' => $description,
                                 'text' => $text,
                                 'active' => 1);
            }
        }
    
        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();
    
        // Return the items
        return $items;
    }

    function api_getstatuses( $args )
    {
        // Get arguments from argument array - all arguments to this function
        // should be obtained from the $args array, getting them from other places
        // such as the environment is not allowed, as that makes assumptions that
        // will not hold in future versions of PostNuke
        extract($args);
    
        $items = array();
    
        // Security check - important to do this as early on as possible to 
        // avoid potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_READ)) {
            return $items;
        }
    
        // Get datbase setup - note that both pnDBGetConn() and pnDBGetTables()
        // return arrays but we handle them differently.  For pnDBGetConn() we
        // currently just want the first item, which is the official database
        // handle.  For pnDBGetTables() we want to keep the entire tables array
        // together for easy reference later on
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();

        // It's good practice to name the table and column definitions you are
        // getting - $table and $column don't cut it in more complex modules
        $statuses_table = $pntable['ce_statuses'];
        $statuses_column = &$pntable['ce_statuses_column'];
    
        // Get items - the formatting here is not mandatory, but it does make the
        // SQL statement relatively easy to read.  Also, separating out the sql
        // statement from the SelectLimit() command allows for simpler debug
        // operation if it is ever needed
        $sql = "SELECT $statuses_column[id],
                       $statuses_column[parent_id],
                       $statuses_column[title],
                       $statuses_column[language]
                FROM $statuses_table
                ORDER BY $statuses_column[id]";
        $result = $dbconn->Execute($sql);
    
        // Check for an error with the database code, and if so set an appropriate
        // error message and return
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _GETFAILED);
            return false;
        }
    
        // Put items into result array.  Note that each item is checked
        // individually to ensure that the user is allowed access to it before it
        // is added to the results array
        for (; !$result->EOF; $result->MoveNext()) {
            list($id, $parent_id, $title, $language) = $result->fields;
            if (pnSecAuthAction(0, 'ContentExpress::Content', "::", ACCESS_READ)) {
                $items[] = array('id' => $id,
                                 'parent_id' => $parent_id,
                                 'title' => $title,
                                 'language' => $language,
                                 'active' => 1);
            }
        }

        // All successful database queries produce a result set, and that result
        // set should be closed when it has been finished with
        $result->Close();

        // Return the items
        return $items;
    }

    function api_updateread($args)
    {
        //API call for updating the times read field of a contentitem
        extract($args);
        //check whether we have ceid to update, else return
        if (!isset($ceid)) {
            pnSessionSetVar('errormsg', _MODARGSERROR);
            return false;
        }
        if (!isset($currentval)){
            $currentval = 0;
        }
        //check whether we have permission to read the article. If not there is no need to update the field
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_READ)) {
            pnSessionSetVar('errormsg', _MENUCONTENTNOSUCHITEM);
            return false;
        }
        //get the tables
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $contentitems_table = $pntable['ce_contentitems'];
        $contentitems_column = &$pntable['ce_contentitems_column'];
        //Update SQl  statement
        $currentval = ++$currentval;
        $sql =  "UPDATE $contentitems_table ";
        $sql .= "SET $contentitems_column[times_read] = $currentval ";
        $sql .= "WHERE $contentitems_column[id] = $ceid;";
        //execute the sql and check for errors
        $result = $dbconn->Execute($sql);
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar ('errormsg', _MENUCONTENTITEMSQLFAIL.$sql);
            return false;
        }
        
        $result->Close();
        return $currentval;


    }

    function api_buildindex( &$output,$array,$item,$spacer="",$depthcounter=0)
    {
        //The output param is given as a return value, so any displaying output can be added straight
        //to this variable.
        //list($output,$array,$item) = pnVarCleanFromInput('output','array','items');
        $show_times_read_index = pnModGetVar('ContentExpress','show_times_read_index');
        $show_author_index = pnModGetVar('ContentExpress','show_author_index');
        $mytheme = pnUserGetTheme();
        $output->SetInputMode(_PNH_PARSEINPUT);
        $itemurl = CommonExpress_display_themeable_anchor( $mytheme,
                                                       pnModURL( 'ContentExpress', 'user', 'display',
                                                                 array( 'ceid' => $item['id'] )),
                                                       $item['title'], "Topic" );
        $row = array();

        $entry = $itemurl;
        if ($show_times_read_index ){
          $entry .= "  (".$item['times_read']." x "._CONTENTITEMREAD.")";
        }
        /*
        if ($show_last_updated||($item['show_last_updated']>0 && !$show_last_updated )){
          $entry .= "  "._CONTENTITEMLASTUPDATED." : ".$item['last_updated'];
        }
        */
        if ($show_author_index){
          $entry .= " "._CONTENTITEMBY." ".$item['author'];
        }
        $row[] = $entry;
        $child = $item['child'];
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));
        $moddir = pnVarPrepForOS($modinfo['directory']);
        $itemid = $item['id'];
        $blank = "<img border=\"0\" width=\"12\" src=\"modules/$moddir/pnimages/blank.gif\">";
        $collapsedimg = "<img border=\"0\" width=\"12\" src=\"modules/$moddir/pnimages/squareplus.gif\">";
        if ( count ($child) > 0 )
        {
            $levelspacer = $spacer.$collapsedimg."&nbsp;";
        }
        else
        {
            $levelspacer = $spacer.$blank."&nbsp;";
        }
        $row[0] = "$levelspacer$row[0]";
        //$row[] = join( "&nbsp;|&nbsp;", $item['actions'] );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddRow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
        if (($depthcounter < pnModGetVar('ContentExpress','index_depth'))||(pnModGetVar('ContentExpress','index_depth')== -1))
        {
            if( count( $child ) > 0 )
            {
                $spacer = $spacer.$blank."&nbsp;";
                $depthcounter++;
                foreach( $child as $child_id ) {
                    $this->api_buildindex($output, $array, $array[$child_id],$spacer,$depthcounter);

                }
            }
        }
    }

    function admin_new()
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADD)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Add content to output - it helps if all of the module pages have a standard
        // content at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->Text($this->admin_view( array( 'ceid' => -1, 'action' => "editcontent" )));
        $output->Linebreak();
        $output->Text($this->admin_build_form( _MENUCONTENTADDCONTENT, _MENUCONTENTSAVECONTENT ));

        $output->SetInputMode(_PNH_PARSEINPUT);

        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableStart( "", "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();
   
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_create( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($parent_id, $cat_id, $language, $title, $title_align, $text, $enable_title,
             $media_url, $media_width, $media_height, $media_text, $layout_id,
             $start_date, $end_date, $top_print, $bottom_print, $status,
             $upld_media_name, $upld_media_type, $upld_media_size,
             $weight, $navigation, $top_sendfriend, $bottom_sendfriend,
             $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
             $author, $notes ) =
        pnVarCleanFromInput('parent_id', 'cat_id', 'language', 'title', 'title_align', 'text', 'enable_title',
                            'media_url', 'media_width', 'media_height', 'media_text', 'layout_id',
                            'start_date', 'end_date', 'top_print', 'bottom_print', 'status',
                            'upld_media_name', 'upld_media_type', 'upld_media_size',
                            'weight', 'navigation', 'top_sendfriend', 'bottom_sendfriend',
                            'backgroundcolor','last_updated','times_read','show_last_updated','show_times_read',
                            'author', 'notes');

        global $upld_media; // Fix for upload image problem on Windows

        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);

        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcontent'));
            return true;
        }
    
        if( strlen( trim( $title )) == 0 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGTITLE);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcontent'));
            return true;
        }

        if( is_array( $upld_media )) {
            $upld_media_name = $upld_media['name'];
            $upld_media_type = $upld_media['type'];
            $upld_media_size = $upld_media['size'];
            $upld_media = $upld_media['tmp_name'];
        }

        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the creation of the new item is
        // done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array
        $id = pnModAPIFunc('ContentExpress',
                           'admin',
                           'createcontent',
                           array(
                                 'parent_id' => $parent_id,
                                 'cat_id' => $cat_id,
                                 'language' => $language,
                                 'title' => $title,
                                 'title_align' => $title_align,
                                 'text' => $text,
                                 'enable_title' => $enable_title,
                                 'media_url' => $media_url,
                                 'media_width' => $media_width,
                                 'media_height' => $media_height,
                                 'media_text' => $media_text,
                                 'layout_id' => $layout_id,
                                 'start_date' => $start_date,
                                 'end_date' => $end_date,
                                 'top_print' => $top_print,
                                 'bottom_print' => $bottom_print,
                                 'upld_media' => $upld_media,
                                 'upld_media_name' => $upld_media_name,
                                 'upld_media_type' => $upld_media_type,
                                 'upld_media_size' => $upld_media_size,
                                 'status' => $status,
                                 'weight' => $weight,
                                 'navigation' => $navigation,
                                 'top_sendfriend' => $top_sendfriend,
                                 'bottom_sendfriend' => $bottom_sendfriend,
                                 'backgroundcolor' => $backgroundcolor,
                                 'last_updated' => $last_updated,
                                 'times_read' => $times_read,
                                 'show_last_updated' => $show_last_updated,
                                 'show_times_read' => $show_times_read,
                                 'author' => $author,
                                 'notes' => $notes));
    
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if ($id != false) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCONTENTCREATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newcontent'));
    
        // Return
        return true;
    }

    function admin_view($args)
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();
    
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        
        extract($args);
        
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_contentitems',
                              array('modulemode'=>'admin'));

        if ($items == false) {
            // Since there will be time when there is nothing in the table, so
            // it won't make sense to say no such item here.
            //$output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }

        $output->SetOutputMode(_PNH_RETURNOUTPUT);

        // Get the content info
        $curr_ceid = $ceid;

        // Built the content tree
        $prev_pid = -1;
        $prev_weight_min = 999999999999;
        $prev_cid = -1;
        $contents = array();
        foreach($items as $item) {
            $id = $item['id'];
            $parent_id = $item['parent_id'];
            $title = $item['title'];
            $weight = $item['weight'];
            $status = $item['status'];
            $actions = array();
    
            if( $prev_pid != $parent_id ) {
                $prev_pid = $parent_id;
                $prev_weight_min = 999999999999;
                $contents[$prev_cid]['actions'][7] = $output->Text( _MENUCONTENTMOVEDOWN );
            } else if( $prev_cid != -1 ) {
                $contents[$prev_cid]['actions'][7] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $prev_cid, 'pid' => $id, 'task' => 'down', 'authid' => pnSecGenAuthKey() )),
                                                             _MENUCONTENTMOVEDOWN );
            }
    
            $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "editcontent", array( 'ceid' => $id )),
                                    _MENUCONTENTEDIT );
            $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "delcontent", array( 'ceid' => $id )),
                                    _MENUCONTENTDELETE );
    
            if( $status == 2 ) {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $id, 'task' => 'deact', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTDEACTIVATE );
            } else {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $id, 'task' => 'act', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTACTIVATE );
            }
    
            if( $parent_id != -1 ) {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $id, 'pid' => $parent_id, 'task' => 'left', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVELEFT );
            } else {
                $actions[] = $output->Text( _MENUCONTENTMOVELEFT );
            }
            if( $prev_weight_min > $weight ) {
                $actions[] = $output->Text( _MENUCONTENTMOVERIGHT );
                $actions[] = $output->Text( _MENUCONTENTMOVEUP );
                $prev_weight_min = $weight;
            } else {
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $id, 'pid' => $prev_cid, 'task' => 'right', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVERIGHT );
                $actions[] = $output->URL( pnModURL( "ContentExpress", "admin", "qupdcontent", array( 'ceid' => $id, 'pid' => $prev_cid, 'task' => 'up', 'authid' => pnSecGenAuthKey() )),
                                        _MENUCONTENTMOVEUP );
            }
    
            $contents[($id+0)] = array( 'id'      => ($id+0),
					'title'   => $title,
                                        'actions' => $actions,
                                        'parent'  => ($parent_id+0),
                                        'child'   => array() );
            $prev_cid = ($id+0);
        }
        $contents[$prev_cid]['actions'][7] = $output->Text( _MENUCONTENTMOVEDOWN );
    
        foreach( $contents as $id => $contentitem ) {
            $parent_id = $contentitem['parent'];
            if( $parent_id > 0 && !empty( $contents[$parent_id] )) {
                // locates the parent and then updates its child list
                array_push( $contents[$parent_id]['child'], $id );
            }
        }
        // Expand all sibling content items along the content path 
        $contents2 = array();

        CommonExpress_build_dynitems_tree( $contents, $contents2, $curr_ceid );
    
        // Start listing all content items
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableStart( _MENUCONTENTVIEWCONTENTS, "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTCONTENTNAME );
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        $output->BoldText( _MENUCONTENTCONTENTOPTIONS );
        $output->TableColEnd();
        foreach( $contents2 as $id => $contentitem ) {
            if( $contentitem['parent'] == -1 ) {
                CommonExpress_build_viewitems_tree( $output, "ceid", $curr_ceid, $contents2, $contentitem, $action);
            }
        }
        $output->TableRowEnd();
        $output->TableEnd();

        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_edit( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($ceid, $objectid)= pnVarCleanFromInput('ceid', 'objectid');
    
        // Admin functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $ceid = $objectid;
        }

        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $currlang = pnUserGetLang();
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_contentitem',
                             array('ceid' => $ceid));
        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
        // Insert id field with value of ceid so we don't need yet another argument
        // for admin_build_form()
        $item['id'] = $ceid;
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$item[id]", ACCESS_EDIT)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Add content to output - it helps if all of the module pages have a standard
        // content at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->Text($this->admin_view( array( 'ceid' => $ceid, 'action' => "editcontent" )));
        $output->Linebreak();
        $output->Text($this->admin_build_form( _MENUCONTENTCONTENTEDIT, _MENUCONTENTUPDATECONTENT, $item ));
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Get module information for footer
        $modinfo = pnModGetInfo(pnModGetIDFromName('ContentExpress'));

        $output->TableStart( "", "", 0, "100%", 0, 0 );
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        ContentExpress_footer( $output, $modinfo );
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableEnd();
   
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_update( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($ceid, $objectid, $parent_id, $cat_id, $language, $title, $title_align, $text, $enable_title,
             $media_url, $media_width, $media_height, $media_text, $media_type,
             $upld_media_name, $upld_media_type, $upld_media_size, $layout_id,
             $start_date, $end_date, $top_print, $bottom_print,
             $status, $weight, $navigation, $top_sendfriend, $bottom_sendfriend,
             $backgroundcolor, $last_updated, $times_read, $show_last_updated, $show_times_read,
             $author, $notes) =
            pnVarCleanFromInput('ceid', 'objectid', 'parent_id', 'cat_id',
                                'language', 'title', 'title_align', 'text', 'enable_title',
                                'media_url', 'media_width', 'media_height', 'media_text',
                                'media_type', 'upld_media_name', 'upld_media_type', 'upld_media_size',
                                'layout_id', 'start_date', 'end_date', 'top_print', 'bottom_print',
                                'status', 'weight', 'navigation',
                                'top_sendfriend', 'bottom_sendfriend', 'backgroundcolor',
                                'last_updated', 'times_read','show_last_updated', 'show_times_read',
                                'author','notes');
    
        global $upld_media; // Fix for upload image problem for windows
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
                                
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $ceid = $objectid;
        }                       
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcontent',array('ceid' => $ceid) ));
            return true;
        }
    
        if( strlen( trim( $title )) == 0 ) {
            pnSessionSetVar('errormsg', _MENUCONTENTMISSINGTITLE);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcontent', array('ceid' => $ceid) ));
            return true;
        }
    
        if( is_array( $upld_media )) {
            $upld_media_name = $upld_media['name'];
            $upld_media_type = $upld_media['type'];
            $upld_media_size = $upld_media['size'];
            $upld_media = $upld_media['tmp_name'];
        }

        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if(pnModAPIFunc('ContentExpress',
                        'admin',
                        'updatecontent',
                        array('ceid' => $ceid,
                              'parent_id' => $parent_id,
                              'cat_id' => $cat_id,
                              'language' => $language,
                              'title' => $title,
                              'title_align' => $title_align,
                              'text' => $text,
                              'enable_title' => $enable_title,
                              'media_url' => $media_url,
                              'media_width' => $media_width,
                              'media_height' => $media_height,
                              'media_text' => $media_text,
                              'media_type' => $media_type,
                              'layout_id' => $layout_id,
                              'upld_media' => $upld_media,
                              'upld_media_name' => $upld_media_name,
                              'upld_media_type' => $upld_media_type,
                              'upld_media_size' => $upld_media_size,
                              'start_date' => $start_date,
                              'end_date' => $end_date,
                              'top_print' => $top_print,
                              'bottom_print' => $bottom_print,
                              'status' => $status,
                              'weight' => $weight,
                              'navigation' => $navigation,
                              'top_sendfriend' => $top_sendfriend,
                              'bottom_sendfriend' => $bottom_sendfriend,
                              'backgroundcolor' => $backgroundcolor,
                              'last_updated' => $last_updated,
                              'times_read' => $times_read,
                              'show_last_updated' => $show_last_updated,
                              'show_times_read' => $show_times_read,
                              'author' => $author,
                              'notes' => $notes
                              ))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCONTENTUPDATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editcontent',array('ceid' => $ceid) ));
    
        // Return
        return true;
    }

    function admin_delete( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($ceid,
             $objectid,
             $confirmation) = pnVarCleanFromInput('ceid',
                                                  'objectid',
                                                  'confirmation');
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
         // At this stage we check to see if we have been passed $objectid, the
         // generic item identifier.  This could have been passed in by a hook or
         // through some other function calling this as part of a larger module, but
         // if it exists it overrides $tid
         //
         // Note that this module couuld just use $objectid everywhere to avoid all
         // of this munging of variables, but then the resultant code is less
         // descriptive, especially where multiple objects are being used.  The
         // decision of which of these ways to go is up to the module developer
         if (!empty($objectid)) {
             $ceid = $objectid;
         }                     
    
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The user API function is called.  This takes the item ID which we
        // obtained from the input and gets us the information on the appropriate
        // item.  If the item does not exist we post an appropriate message and
        // return
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_contentitem',
                             array('ceid' => $ceid));

        if ($item == false) {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
    
        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing.  However,
        // in this case we had to wait until we could obtain the item name to
        // complete the instance information so this is the first chance we get to
        // do the check
        if (!pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$ceid", ACCESS_DELETE)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
    
        // Check for confirmation. 
        if (empty($confirmation)) {
            // No confirmation yet - display a suitable form to obtain confirmation
            // of this action from the user
    
            // Create output object - this object will store all of our output so
            // that we can return it easily when required
            $output = new pnCEHTML();
    
            // Add content to output - it helps if all of the module pages have a
            // standard content at their head to aid in navigation
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
            $output->SetInputMode(_PNH_PARSEINPUT);
    
            // Title - putting a title ad the head of each page reminds the user
            // what they are doing
            $output->Title(_MENUCONTENTCONTENTDELETE);
    
            // Add confirmation to output.  Note that this uses a pnHTML helper
            // function to produce the requested confirmation in a standard
            // fashion.  This not only cuts down on code within the module but
            // allows it to be altered in future without the module developer
            // having to worry about it
            $output->ConfirmAction(_CONFIRMMENUCONTENTCONTENTDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'delcontent'),
                                   _CANCELMENUCONTENTCONTENTDELETE,
                                   pnModURL('ContentExpress',
                                            'admin',
                                            'newcontent'),
                                   array('ceid' => $ceid));
    
            // Return the output that has been generated by this function
            return $output->GetOutput();
        }
    
        // If we get here it means that the user has confirmed the action
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'newcontent'));
            return true;
        }
    
        // Load API.  All of the actual work for the deletion of the item is done
        // within the API, so we need to load that in before before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if (pnModAPIFunc('ContentExpress',
                         'admin',
                         'deletecontent',
                         array('ceid' => $ceid))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCONTENTDELETED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'newcontent'));
        
        // Return
        return true;
    }

    function admin_qupdate( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        list($task, $ceid, $pid) = pnVarCleanFromInput('task', 'ceid', 'pid' );
    
        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'editcontent',array('ceid' => $ceid) ));
            return true;
        }
    
        // Notable by its absence there is no security check here.  This is because
        // the security check is carried out within the API function and as such we
        // do not duplicate the work here
    
        // Load API.  All of the actual work for the update of the new item is done
        // within the API, so we need to load that in before we can do anything.
        // If the API fails to load an appropriate error message is posted and the
        // function returns
        if (!pnModAPILoad('ContentExpress', 'admin')) {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
    
        // The API function is called.  Note that the name of the API function and
        // the name of this function are identical, this helps a lot when
        // programming more complex modules.  The arguments to the function are
        // passed in as their own arguments array.
        //
        // The return value of the function is checked here, and if the function
        // suceeded then an appropriate message is posted.  Note that if the
        // function did not succeed then the API function should have already
        // posted a failure message so no action is required
        if(pnModAPIFunc('ContentExpress',
                        'admin',
                        'qupdcontent',
                        array('ceid' => $ceid,
                              'pid' => $pid,
                              'task' => $task))) {
            // Success
            pnSessionSetVar('statusmsg', _MENUCONTENTCONTENTUPDATED);
        }
    
        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'editcontent', array('ceid' => $ceid) ));
    
        // Return
        return true;
    }

    // function to build content form
    function admin_build_form( $title, $btn_label, $item = 0 )
    {
        $output = new pnCEHTML();
        $mytheme = pnUserGetTheme();
    
        $currlang = pnUserGetLang();
        $wysiwyg = pnModGetVar('ContentExpress', 'enable_wysiwyg');
        $wysiwyg_height = pnModGetVar('ContentExpress', 'wysiwyg_height');
        $wysiwyg_width = pnModGetVar('ContentExpress', 'wysiwyg_width');
    
        $contents = array();
        if( $item != 0 && !empty( $item )) {
            CommonExpress_build_item_list($contents, "contentitems", $item['id'] );
        }
        else {
            CommonExpress_build_item_list($contents, "contentitems");
        }
    
        $layouts = array();
        CommonExpress_build_item_list($layouts, "layoutitems");
    
        $categories = array();
        CommonExpress_build_item_list($categories, "categories");
    
        $statuses = array();
        CommonExpress_build_item_list($statuses, "statusitems" );

        // Lookup the directory for an existing list of media files
        $media_list = array();
        $media_list[] = array( 'id' => "", 'selected' => 0, 'name' => "" );
        CommonExpress_build_medialist( $media_list );
    
        // Title - putting a title ad the head of each page reminds the user what
        // they are doing
        $output->Title($title);
    
        // Start form - note the use of pnModURL() to create the recipient URL of
        // this form.  All URLs should be generated through pnModURL() to ensure
        // compatibility with future versions of PostNuke
        $output->UploadMode();
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( '<script type="text/javascript" src="modules/ContentExpress/js/content_validate.js"></script>' );
        $output->SetInputMode(_PNH_PARSEINPUT);

    
        // Start the table that holds the information to be input.  Note how each
        // item in the form is kept logically separate in the code; this helps to
        // see which part of the code is responsible for the display of each item,
        // and helps with future modifications
        $output->TableStart( "", "", 0, "100%", 0, 0 );

        if( $item != 0 ) {

            // If not using WYSIWYG editor, then display the preview,
            // otherwise we don't need preview along with WYSIWYG editor.
            if( $wysiwyg == "none" || !$output->IsWYSIWYGAble() ) {
                $output->TableRowStart();
                if( $item['title_align'] == 1 ) {
                    $output->TableColStart( 4, 'left' );
                } else if( $item['title_align'] == 2 ) {
                    $output->TableColStart( 4, 'center' );
                } else if( $item['title_align'] == 3 ) {
                    $output->TableColStart( 4, 'right' );
                }

                // In view of current editable content
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text( "<b><font class=\"pn-content-page-title\">".pnVarCensor( $item['title'] )."</font></b>" );
                $output->SetInputMode(_PNH_PARSEINPUT);
                $output->Linebreak(2);
                $output->TableColEnd();
                $output->TableRowEnd();
                $output->TableRowStart();
                $output->TableColStart( 4, 'left' );
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                if( strlen($item['media_url']) > 0 ) {
                    // bug fix from ekkehard. Many thanks!!
                    if( $item['layout_id'] == 1 || $item['layout_id'] == 3 ) {
                        $media_pos = "left";
                    } else if( $item['layout_id'] == 2 || $item['layout_id'] == 4 ) {
                        $media_pos = "right";
                    }
                    if( ereg( "flash", $item['media_type'] )) {
                        $media_tag = "<object codebase=\"modules/ContentExpress/".$item['media_url']."\" align=\"$media_pos\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\"><param name=movie value=\"modules/ContentExpress/".$item['media_url']."\"><param name=quality value=high><embed src=\"modules/ContentExpress/".$item['media_url']."\" quality=high pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\" align=\"$media_pos\"></embed></object>";
                    }
                    else if( ereg( "image", $item['media_type'] )) {
                        if( $item['media_width'] > 0 && $item['media_height'] > 0 ) {
                            $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$item['media_url']."\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\">";
                        }
                        else {
                            $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$item['media_url']."\">";
                        }
                    } else {
                        $media_tag = "<a href=\"modules/ContentExpress/".$item['media_url']."\"><img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/pnimages/download.gif\"></a>";
                    }
                    if( $item['layout_id'] == 1 || $item['layout_id'] == 2 ) {
                        $output->Text( $media_tag );
                    // bug fix from ekkehard. Many thanks!!
                    } else if( $item['layout_id'] == 5) {
                        $output->Text("<center>".$media_tag."</center>");
                    }
                    $output->Text( "<font class=\"pn-content-page-body\">".pnVarCensor( $item['text'] )."</font>" );
                    if( $item['layout_id'] == 3 || $item['layout_id'] == 4 ) {
                        $output->Text( $media_tag );
                    // bug fix from ekkehard. Many thanks!!
                    } else if( $item['layout_id'] == 6) {
                        $output->Text("<center>".$media_tag."</center>");
                    }
                }
                else {
                    $output->Text( "<font class=\"pn-content-page-body\">".pnVarCensor( $item['text'] )."</font>" );
                }
                $output->Linebreak(3);
                $output->TableColEnd();
                $output->TableRowEnd();
                $output->SetInputMode(_PNH_PARSEINPUT);
            }

            if( $wysiwyg != "none" && $output->IsWYSIWYGAble() ) {
                $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'updatecontent'), 'editcontent', 'text' );
            } else {
                $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'updatecontent'), 'editcontent');
            }
        
            // Add a hidden variable for the item id.  This needs to be passed on to
            // the update function so that it knows which item for which item to carry
            // out the update
            $output->FormHidden('ceid', pnVarPrepForDisplay($item['id']));
    
        }
        else {
            if( $wysiwyg != "none" && $output->IsWYSIWYGAble() ) {
                $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'createcontent'), 'newcontent', 'text' );
            } else {
                $output->CEFormStart(pnModURL('ContentExpress', 'admin', 'createcontent'), 'newcontent');
            }
        }
    
        // Add an authorisation ID - this adds a hidden field in the form that
        // contains an authorisation ID.  The authorisation ID is very important in
        // preventing certain attacks on the website
        $output->FormHidden('authid', pnSecGenAuthKey());
    
        // Name
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTNAME));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('title', $item['title'], 64, 64);
        } else {
            $output->FormText('title', '', 64, 64);
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        // Title Alignment
        $aligns = array();
        $aligns[] = array( 'id' => 1, 'selected' => ($item['title_align'] == 1)?1:0, 'name' => _MENUCONTENTMOVELEFT );
        $aligns[] = array( 'id' => 2, 'selected' => ($item['title_align'] == 2)?1:0, 'name' => _MENUCONTENTCENTER );
        $aligns[] = array( 'id' => 3, 'selected' => ($item['title_align'] == 3)?1:0, 'name' => _MENUCONTENTMOVERIGHT );

        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTTITLEALIGN));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('title_align', $aligns, 0, 1, $item['title_align'] );
        } else {
            $output->FormSelectMultiple('title_align', $aligns );
        }
        $output->TableColEnd();
        $output->TableColStart( 2, 'left' );
        // Enable/Disable title
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('enable_title', $item['enable_title'] ? true : false );
        } else {
            $output->FormCheckbox('enable_title', true );
        }
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTTITLEACTIVE));
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Category
        // Category list should be retreived from database
        $category_list = array();
        if( is_array( $categories )) {
            foreach( $categories as $id => $category ) {
                $category_list[] = array( 'id' => $id, 'selected' => 0, 'name' => $category );
            }
        }
    
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTCATEGORY));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('cat_id', $category_list, 0, 1, $item['cat_id'] );
        } else {
            $output->FormSelectMultiple('cat_id', $category_list, 0, 1 );
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Content
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTTEXT));
        $output->TableColEnd();
        $output->TableRowEnd();
        $output->TableRowStart();
        $output->TableColStart( 4, 'left' );
        if( $item != 0 && !empty( $item )) {
            if( $wysiwyg != "none" && $output->IsWYSIWYGAble() ) {
                $output->CEFormTextArea('text', $item['text'], $wysiwyg_height, $wysiwyg_width );
            } else {
                $output->FormTextArea('text', $item['text'], $wysiwyg_height, $wysiwyg_width );
            }
        } else {
            if( $wysiwyg != "none" && $output->IsWYSIWYGAble() ) {
                $output->CEFormTextArea('text', '', $wysiwyg_height, $wysiwyg_width );
            } else {
                $output->FormTextArea('text', '', $wysiwyg_height, $wysiwyg_width);
            }
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // Parent Content
        // parent list should be retreived from database
        $parents = array();
        $parents[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTTOPLEVEL );
        foreach( $contents as $id => $content ) {
            $parents[] = array( 'id' => $id, 'selected' => ($item['parent_id']==$id)?1:0, 'name' => $content );
        }
    
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTPARENT));
        $output->TableColEnd();
        $output->TableColStart( 3, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('parent_id', $parents, 0, 1, $item['parent_id'] );
        } else {
            $output->FormSelectMultiple('parent_id', $parents );
        }
        $output->TableColEnd();
        $output->TableRowEnd();
    
        // If WYSIWYG editor is enabled, then user don't really need this media-related form,
        // because WYSIWYG editor already include those and it is much better to use.
	// Commented out due to the fact that the implementation of the media insert only support image
	// not all media types
        $max_media_size = pnModGetVar('MediaExpress', 'max_media_size' );
//        if( $wysiwyg  == "none" || ! $output->IsWYSIWYGAble() ) {

            // Media Upload
            $output->TableRowStart();
            $output->TableColStart( 1, 'left' );
            $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTIMAGEUPLD));
            $output->TableColEnd();
            $output->TableColStart( 3, 'left' );
            if( $item != 0 && !empty( $item )) {
                $output->FormSelectMultiple('media_url', $media_list, 0, 1, $item['media_url'],'','onChange="selectImg(this)"');
                $output->Text( " " ); 
                $output->FormFile('upld_media', 32, $max_media_size);
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text('<div id="panel"></div>');
                $output->SetInputMode(_PNH_PARSEINPUT);
            } else {
                $output->FormSelectMultiple('media_url', $media_list, 0, 1, '','','onChange="selectImg(this)"');
                $output->Text( " " );
                $output->FormFile('upld_media', 32, $max_media_size);
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text('<div id="panel"></div>');
                $output->SetInputMode(_PNH_PARSEINPUT);
            }
            $output->TableColEnd();
            $output->TableRowEnd();
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text( '<script type="text/javascript">'  
    		       .'function displayImg(src) {'
                       .'    return \'<img name="myimg" src="\'+src+\'" align="top">\';'
    		       .'}'
                       .'function displayFlash(src) {'
                       .'    return \'<OBJECT id="mymovie" CLASSID="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" WIDTH="100" HEIGHT="100" CODEBASE="http://active.macromedia.com/flash5/cabs/swflash.cab#version=5,0,0,0"><PARAM NAME="MOVIE" VALUE="\'+src+\'"><PARAM NAME="PLAY" VALUE="true"><PARAM NAME="LOOP" VALUE="true"><PARAM NAME="QUALITY" VALUE="high"><EMBED id="mymovie" SRC="\'+src+\'" WIDTH="100" HEIGHT="100" PLAY="true" LOOP="true" QUALITY="high" PLUGINSPAGE="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash"></EMBED></OBJECT>\';'
     	               .'}'
    		       .'function selectImg(elm) { '
                       .'  var fileStr = elm.value;'
                       .'  var imgelm = document.getElementById("panel");'
                       .'  var fileExt = fileStr.substring(fileStr.length-4, fileStr.length);' 
     		       .'  if ( fileExt.toLowerCase() == ".gif" || fileExt.toLowerCase() == ".jpg" || fileExt.toLowerCase() == ".jpe" || fileExt.toLowerCase() == ".png" || fileStr.substring(fileStr.length-5, fileStr.length).toLowerCase() == ".jpeg") {'
    		       .'   imgelm.innerHTML = displayImg( "modules/'.pnModGetName().'/"+elm.value);'
                       .'  } else if (fileExt.toLowerCase() == ".swf"){'
                       .'   imgelm.innerHTML = displayFlash( "modules/'.pnModGetName().'/"+elm.value);'
                       .'  } else {'
           	       .'      imgelm.innerHTML = "";'
                       .'  }'
       		       .'}');
    
            $output->Text( '</script>');
            $output->SetInputMode(_PNH_PARSEINPUT);
        
            // Media width/height
            $def_media_width = pnModGetVar('MediaExpress', 'media_width');
            $def_media_height = pnModGetVar('MediaExpress', 'media_height');
        
            $output->TableRowStart();
            $output->TableColStart( 1, 'left' );
            $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTIMAGEDIM));
            $output->TableColEnd();
            $output->TableColStart( 3, 'left' );
            if( $item != 0 && !empty( $item )) {
                $output->FormText('media_width', $item['media_width'], 3, 3);
                $output->Text( " x " );
                $output->FormText('media_height', $item['media_height'], 3, 3);
                $output->Text( " "._MENUCONTENTCONTENTIMAGEDIMHELP );
                $output->FormHidden('media_type', $item['media_type']);
            } else {
                $output->FormText('media_width', $def_media_width, 3, 3);
                $output->Text( " x " );
                $output->FormText('media_height', $def_media_height, 3, 3);
                $output->Text( " "._MENUCONTENTCONTENTIMAGEDIMHELP );
            }
            $output->TableColEnd();
            $output->TableRowEnd();
        
            // layout list should be retreived from database
            $layout_list = array();
            $layout_list[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTCONTENTNOLAYOUT );
            foreach( $layouts as $id => $layout ) {
                $layout_list[] = array( 'id' => $id, 'selected' => 0, 'name' => $layout );
            }
        
            // Layout of Content
            $output->TableRowStart();
            $output->TableColStart( 1, 'left' );
            $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTLAYOUT));
            $output->TableColEnd();
            $output->TableColStart( 3, 'left' );
            if( $item != 0 && !empty( $item )) {
                $output->FormSelectMultiple('layout_id', $layout_list, 0, 1, $item['layout_id'] );
            } else {
                $output->FormSelectMultiple('layout_id', $layout_list );
            }
            $output->TableColEnd();
            $output->TableRowEnd();
//        }
    
        // Language
        $output->TableRowStart();
        $languages = languagelist();
        $langs = array();
        $langs[] = array( 'id' => 'x_all', 'selected' => 0, 'name' => 'All' );
        foreach( $languages as $l => $lan ) {
            if( $l == $item['language'] ) {
            //bc:(|| $l == $currlang) took this part out of the equation, because it conflicts
            //when editing an item, it doesn't give the items language anymore
            //now when making a new item, it says "All"
                $langs[] = array( 'id' => $l, 'selected' => 1, 'name' => $lan );
            }
            else {
                $langs[] = array( 'id' => $l, 'selected' => 0, 'name' => $lan );
            }
        }
    
        $output->TableColStart( 1, 'left' );

        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTLANG));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('language', $langs, 0, 1, $item['language'] );
        } else {
            $output->FormSelectMultiple('language', $langs );
        }
        $output->TableColEnd();

        // Schedule content label
        $output->TableColStart( 2, 'left' );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text("<b>".pnVarPrepForDisplay(_MENUCONTENTSCHEDULE)."</b>");
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();

        // popup calendar javascript
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( '<script type="text/javascript" src="modules/ContentExpress/js/ts_picker.js">'.
                       '//Script by Denis Gritcyuk: tspicker@yahoo.com'.
                       '//Submitted to JavaScript Kit (http://javascriptkit.com)'.
                       '//Visit http://javascriptkit.com for this script' );  
        $output->Text( '</script>' );
        $output->SetInputMode(_PNH_PARSEINPUT);

        //popup color picker
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text( "<script type=\"text/javascript\" src=\"modules/ContentExpress/js/picker.js\"></script>" );
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable top print anchor
        $output->TableRowStart();
        $output->TableColStart( 1, 'left' );

        $output->Text(pnVarPrepForDisplay(_MENUCONTENTTOPPRINT));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('top_print', $item['top_print'] ? true : false );
        } else {
            $output->FormCheckbox('top_print');
        }
        $output->TableColEnd();

        // Start Date
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTSTARTDATE));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('start_date', $item['start_date']);
        } else {
            $output->FormText('start_date');
        }
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        if( $item != 0 && !empty( $item )) {
            $output->Text( "<a href=\"javascript:show_calendar('document.editcontent.start_date', document.editcontent.start_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        } else {
            $output->Text( "<a href=\"javascript:show_calendar('document.newcontent.start_date', document.newcontent.start_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        }
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();

        // Enable/Disable bottom print anchor
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTBOTTOMPRINT));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('bottom_print', $item['bottom_print'] ? true : false );
        } else {
            $output->FormCheckbox('bottom_print');
        }

        $output->TableColEnd();

        // End Date
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTENDDATE));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormText('end_date', $item['end_date']);
        } else {
            $output->FormText('end_date');
        }
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        if( $item != 0 && !empty( $item )) {
            $output->Text( "<a href=\"javascript:show_calendar('document.editcontent.end_date', document.editcontent.end_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        } else {
            $output->Text( "<a href=\"javascript:show_calendar('document.newcontent.end_date', document.newcontent.end_date.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        }
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();

        $output->TableRowEnd();

        $output->TableRowStart();

        // Status

        $status = array();
        foreach( $statuses as $s => $state ) {
            if( $s == $item['status'] ) {
                $status[] = array( 'id' => $s, 'selected' => 1, 'name' => $state );
            }
            else {
                $status[] = array( 'id' => $s, 'selected' => 0, 'name' => $state );
            }
        }

        $output->TableColStart( 1, 'left' );

        $output->Text(pnVarPrepForDisplay(_MENUCONTENTCONTENTSTATE));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormSelectMultiple('status', $status, 0, 1, $item['status'] );
        } else {
            $output->FormSelectMultiple('status', $status );
        }
        $output->TableColEnd();
        $output->TableRowEnd();


        $output->TableRowStart();
        //Display Navigation
        $output->TableColStart( 1, 'left' );
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTNAVIGATION));
        $output->TableColEnd();
        $output->TableColStart( 1, 'left' );
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('navigation', $item['navigation'] ? true : false );
        } else {
            $output->FormCheckbox('navigation');
        }
        $output->TableColEnd();
        // Weight
        $output->TableColStart( 2, 'left' );

        if( $item != 0 && !empty( $item )) {
            $output->FormHidden('weight', $item['weight']);
        } else {
            $output->FormHidden('weight', '10');
        }

        $output->TableColEnd();
        $output->TableRowEnd();


        $output->TableRowStart();
        //Links SendFriend
        //top sendfriend
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTTOPSENDFRIEND));
        $output->TableColEnd();
        $output->TableColStart(3,'left');
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('top_sendfriend', $item['top_sendfriend'] ? true : false );
        } else {
            $output->FormCheckbox('top_sendfriend');
        }
        $output->TableColEnd();
        $output->TableRowEnd();
        //bottom sendfriend
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTBOTTOMSENDFRIEND));
        $output->TableColEnd();
        $output->TableColStart(3,'left');
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('bottom_sendfriend', $item['bottom_sendfriend'] ? true : false );
        } else {
            $output->FormCheckbox('bottom_sendfriend');
        }
        $output->TableColEnd();

        $output->TableRowEnd();

        //background color
        $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTBACKGROUDCOLOR));
        $output->TableColEnd();
        $output->TableColStart(3,'left');
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->FormText('backgroundcolor', $item['backgroundcolor']);
        if( $item != 0 && !empty( $item )) {
            $output->Text("<script type=\"text/javascript\">ShowTCPButton( 'editcontent', 'backgroundcolor' );</script>");
        } else {
            $output->Text("<script type=\"text/javascript\">ShowTCPButton( 'newcontent', 'backgroundcolor' );</script>");
        }
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableRowEnd();

        //last-updated
        $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTLASTUPDATED));
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        $now = strftime( "%Y-%m-%d %H:%M:%S", time());
        if( $item != 0 && !empty( $item )) {
            $output->FormText('last_updated', $now);//$item['last_updated']
        } else {
            $output->FormText('last_updated');
        }
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        if( $item != 0 && !empty( $item )) {
            $output->Text( "<a href=\"javascript:show_calendar('document.editcontent.last_updated', document.editcontent.last_updated.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        } else {
            $output->Text( "<a href=\"javascript:show_calendar('document.newcontent.last_updated', document.newcontent.last_updated.value);\"><img src=\"modules/ContentExpress/pnimages/cal.gif\" width=\"16\" height=\"16\" border=\"0\" alt=\"Click here to pick the date/time\"></a>");
        }
        //$output->FormText('backgroundcolor', $item['backgroundcolor']);
        //$output->Text("<a href=\"javascript:TCP.popup( document.forms['editcontent'].elements['backgroundcolor'])\"><img width=\"15\" height=\"13\" border=\"0\" alt=\"Click here to pick color\" src=\"modules/ContentExpress/pnimages/sel.gif\"></a>");
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWLASTUPDATED));
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('show_last_updated', $item['show_last_updated'] ? true : false );
        } else {
            $output->FormCheckbox('show_last_updated');
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        //last-updated
        $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTTIMESREAD));
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        $output->FormText('times_read', $item['times_read']);
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWTIMESREAD));
        $output->TableColEnd();
        $output->TableColStart(1,'left');
        if( $item != 0 && !empty( $item )) {
            $output->FormCheckbox('show_times_read', $item['show_times_read'] ? true : false );
        } else {
            $output->FormCheckbox('show_times_read');
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTAUTHOR));
        $output->TableColEnd();
        $output->TableColStart(3,'left');
        $output->FormText('author', $item['author']);
        $output->TableColEnd();
        $output->TableRowEnd();

        $output->TableRowStart();
        $output->TableColStart(1,'left');
        $output->Text(pnVarPrepForDisplay(_MENUCONTENTNOTES));
        $output->TableColEnd();
        $output->TableColStart(3,'left');
        if( $item != 0 && !empty( $item )) {
            $output->FormTextArea('notes', $item['notes'], 5, 50);
        }else{
            $output->FormTextArea('notes', '', 5, 50);
        }
        $output->TableColEnd();
        $output->TableRowEnd();

        //close table
        $output->TableEnd();

        // End form
        $output->FormSubmit($btn_label);
        $output->CEFormEnd();

        return $output->GetOutput();
    }

    function admin_modifyconfig()
    {
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();

        // Security check - important to do this as early as possible to avoid
        // potential security holes or just too much wasted processing

        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_ADMIN)) {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }

        // Add menu to output - it helps if all of the module pages have a standard
        // menu at their head to aid in navigation
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(pnModFunc('ContentExpress', 'admin', 'adminmenu'));
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Title - putting a title ad the head of each page reminds the user what
        // they are doing
        $output->Title(_MENUCONTENTMODIFYCECONFIG);
    
        // Start form - note the use of pnModURL() to create the recipient URL of
        // this form.  All URLs should be generated through pnModURL() to ensure
        // compatibility with future versions of PostNuke
        $output->FormStart(pnModURL('ContentExpress', 'admin', 'updatececonfig'));
    
    
        // Add an authorisation ID - this adds a hidden field in the form that
        // contains an authorisation ID.  The authorisation ID is very important in
        // preventing certain attacks on the website
        $output->FormHidden('authid', pnSecGenAuthKey());
    
        // Start the table that holds the information to be modified.  Note how
        // each item in the form is kept logically separate in the code; this helps
        // to see which part of the code is responsible for the display of each
        // item, and helps with future modifications
        $output->TableStart( "", "", 0, "100%", 0, 0 );
    
        $contents = array();
        CommonExpress_build_item_list( $contents, "contentitems" );
    
        $content_list = array();
        $content_list[] = array( 'id' => -2, 'selected' => 0, 'name' => _MENUCONTENTMENUTYPE6 );
        $content_list[] = array( 'id' => -1, 'selected' => 0, 'name' => _MENUCONTENTMENUTYPE4 );

        foreach( $contents as $id => $content ) {
            $content_list[] = array( 'id' => $id, 'selected' => 0, 'name' => $content );
        }
    
        $pnpeditors = CommonExpress_build_editor_list();
        $pnpeditor_list = array();
        $pnpeditor_list[] = array( 'id' => "none", 'selected' => 0, 'name' => _MENUCONTENTNONE );
        foreach( $pnpeditors as $editor ) {
            $pnpeditor_list[] = $editor;
        }
        $default_cid = pnModGetVar('ContentExpress', 'default_cid');
        $default_url = pnModGetVar('ContentExpress', 'default_url');
        $wysiwyg_height = pnModGetVar('ContentExpress', 'wysiwyg_height');
        $wysiwyg_width = pnModGetVar('ContentExpress', 'wysiwyg_width');
        $enable_aclean = pnModGetVar('ContentExpress', 'enable_aclean');
        $enable_qadmin = pnModGetVar('ContentExpress', 'enable_qadmin');
        $enable_wysiwyg = pnModGetVar('ContentExpress', 'enable_wysiwyg');
        $enable_top_print = pnModGetVar('ContentExpress', 'enable_top_print');
        $enable_bottom_print = pnModGetVar('ContentExpress', 'enable_bottom_print');
        $enable_display_navigation = pnModGetVar('ContentExpress', 'enable_display_navigation');
        $index_depth = pnModGetVar('ContentExpress', 'index_depth');
        $enable_top_sendfriend = pnModGetVar('ContentExpress', 'enable_top_sendfriend');
        $enable_bottom_sendfriend = pnModGetVar('ContentExpress', 'enable_bottom_sendfriend');
        $show_last_updated = pnModGetVar('ContentExpress', 'show_last_updated' );
        $show_times_read = pnModGetVar('ContentExpress', 'show_times_read' );
        $show_times_read_index = pnModGetVar('ContentExpress', 'show_times_read_index' );
        $timeformat = pnModGetVar('ContentExpress', 'timeformat');
        $show_author_index = pnModGetVar('ContentExpress', 'show_author_index' );

        // Default content page
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTDEFAULTCONTENT));
        $row[] = $output->FormSelectMultiple('default_cid', $content_list, 0, 1, $default_cid );
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text( "" );
        $row[] = $output->FormText('default_url', $default_url, 32, 256);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Enable/Disable quick admin link
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTQADMIN));
        $row[] = $output->FormCheckbox('enable_qadmin', $enable_qadmin );
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Enable/Disable auto-clean for media repository
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTAUTOCLEAN));
        $row[] = $output->FormCheckbox('enable_aclean', $enable_aclean );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Enable/Disable WYSIWYG editor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTWYSIWYG));
        $row[] = $output->FormSelectMultiple('enable_wysiwyg', $pnpeditor_list, 0, 1, $enable_wysiwyg );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Define WYSIWYG editor height and width
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text( _CONTENTWYSIWYGHEIGHT );
        $row[] = $output->FormText('wysiwyg_height', $wysiwyg_height, 3, 3);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text( _CONTENTWYSIWYGWIDTH );
        $row[] = $output->FormText('wysiwyg_width', $wysiwyg_width, 3, 3);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable top print anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTTOPPRINT));
        $row[] = $output->FormCheckbox('enable_top_print', $enable_top_print );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable bottom print anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTBOTTOMPRINT));
        $row[] = $output->FormCheckbox('enable_bottom_print', $enable_bottom_print );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable top sendfriend anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTTOPSENDFRIEND));
        $row[] = $output->FormCheckbox('enable_top_sendfriend', $enable_top_sendfriend );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable bottom sendfriend anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTBOTTOMSENDFRIEND));
        $row[] = $output->FormCheckbox('enable_bottom_sendfriend', $enable_bottom_sendfriend );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable Display Navigation anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTNAVIGATION));
        $row[] = $output->FormCheckbox('enable_display_navigation', $enable_display_navigation );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable Display Navigation anchor
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTINDEXDEPTH));
        $row[] = $output->FormText('index_depth', $index_depth, 2, 2 );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable show last updated label
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWLASTUPDATED));
        $row[] = $output->FormCheckbox('show_last_updated', $show_last_updated );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable show times read label
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWTIMESREAD));
        $row[] = $output->FormCheckbox('show_times_read', $show_times_read );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable time format in contentitem
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTTIMEFORMAT));
        $row[] = $output->FormText('timeformat', $timeformat ,32,256);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable show times read label in index page
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWTIMESREADINDEX));
        $row[] = $output->FormCheckbox('show_times_read_index', $show_times_read_index );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Enable/Disable show author label in index page
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSHOWAUTHORINDEX));
        $row[] = $output->FormCheckbox('show_author_index', $show_author_index );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // End form
        $output->TableEnd();
        $output->Linebreak(2);
        $output->FormSubmit(_MENUCONTENTUPDATECONFIG);
        $output->FormEnd();
        
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function admin_updateconfig( $args )
    {
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke
        $default_cid = pnVarCleanFromInput('default_cid');
        $default_url = pnVarCleanFromInput('default_url');
        $enable_qadmin = pnVarCleanFromInput( 'enable_qadmin' );
        $enable_aclean = pnVarCleanFromInput( 'enable_aclean' );
        $enable_wysiwyg = pnVarCleanFromInput( 'enable_wysiwyg' );
        $wysiwyg_height = pnVarCleanFromInput( 'wysiwyg_height' );
        $wysiwyg_width = pnVarCleanFromInput( 'wysiwyg_width' );
        $enable_top_print = pnVarCleanFromInput( 'enable_top_print' );
        $enable_bottom_print = pnVarCleanFromInput( 'enable_bottom_print' );
        $enable_display_navigation = pnVarCleanFromInput( 'enable_display_navigation' );
        $index_depth = pnVarCleanFromInput( 'index_depth' );
        $enable_top_sendfriend = pnVarCleanFromInput( 'enable_top_sendfriend' );
        $enable_bottom_sendfriend = pnVarCleanFromInput( 'enable_bottom_sendfriend' );
        $show_last_updated = pnVarCleanFromInput( 'show_last_updated' );
        $show_times_read = pnVarCleanFromInput( 'show_times_read' );
        $timeformat = pnVarCleanFromInput( 'timeformat' );
        $show_times_read_index = pnVarCleanFromInput( 'show_times_read_index' );
        $show_author_index = pnVarCleanFromInput( 'show_author_index' );

        extract( $args );

        // Confirm authorisation code.  This checks that the form had a valid
        // authorisation code attached to it.  If it did not then the function will
        // proceed no further as it is possible that this is an attempt at sending
        // in false data to the system
        if (!pnSecConfirmAuthKey()) {
            pnSessionSetVar('errormsg', _BADAUTHKEY);
            pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));
            return true;
        }

        // Update module variables.  Note that depending on the HTML structure used
        // to obtain the information from the user it is possible that the values
        // might be unset, so it is important to check them all and assign them
        // default values if required
        if (!isset($default_cid)) {
            //$default_cid = -1; //setting it to the index
            $default_cid = -2;
        }
        pnModSetVar('ContentExpress', 'default_cid', $default_cid);

        if( $default_cid < 0 && $default_cid<>-2 && $default_url != "" ) {
            pnModSetVar('ContentExpress', 'default_url', $default_url);
        } else {
            pnModSetVar('ContentExpress', 'default_url', "" );
        }

        pnModSetVar('ContentExpress', 'enable_qadmin', $enable_qadmin);

        pnModSetVar('ContentExpress', 'enable_aclean', $enable_aclean);

        pnModSetVar('ContentExpress', 'enable_wysiwyg', $enable_wysiwyg);
        pnModSetVar('ContentExpress', 'wysiwyg_height', $wysiwyg_height);
        pnModSetVar('ContentExpress', 'wysiwyg_width', $wysiwyg_width);
        pnModSetVar('ContentExpress', 'enable_top_print', $enable_top_print);
        pnModSetVar('ContentExpress', 'enable_bottom_print', $enable_bottom_print);
        pnModSetVar('ContentExpress', 'enable_display_navigation', $enable_display_navigation);
        pnModSetVar('ContentExpress', 'index_depth', $index_depth);
        pnModSetVar('ContentExpress', 'enable_top_sendfriend', $enable_top_sendfriend);
        pnModSetVar('ContentExpress', 'enable_bottom_sendfriend', $enable_bottom_sendfriend);
        pnModSetVar('ContentExpress', 'show_last_updated', $show_last_updated);
        pnModSetVar('ContentExpress', 'show_times_read', $show_times_read);
        pnModSetVar('ContentExpress', 'timeformat', $timeformat);
        pnModSetVar('ContentExpress', 'show_times_read_index', $show_times_read_index);
        pnModSetVar('ContentExpress', 'show_author_index', $show_author_index);

        pnSessionSetVar('statusmsg', _MENUCONTENTCONFIGUPDATED);

        // This function generated no output, and so now it is complete we redirect
        // the user to an appropriate page for them to carry on their work
        pnRedirect(pnModURL('ContentExpress', 'admin', 'view'));

        // Return
        return true;
    }

    function user_display($args)
    {
        /**
         * display item
         * This is a standard function to provide detailed informtion on a single item
         * available from the module.
         * The page is compose of four different major areas:
         * 1) content parents path hyper links to provide quick access to parent content
         * 2) immediate childrens' title hyper links if any
         *    (those WITH menu item reference ONLY)
         * 3) title of the current content
         * 4) the current content including any immediate sub-contents
         *    (immediate children content WITHOUT menu item reference ONLY)
         */

        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke.
        list($ceid, $meid, $objectid) = pnVarCleanFromInput('ceid', 'meid', 'objectid');

        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);

        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $ceid = $objectid;
        }

        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();




        // Load API.  All of the actual work for obtaining information on the items
        // is done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
            if( $ceid > 0 ) { //Just display the aricle
                $this->display_content( $output, $ceid, $meid );
            }
            elseif ($ceid == -2){ //Display the index page
                $this->display_content( $output, $ceid, $meid );
            }
            else {  //Redirect to the Custom URL
                $default_url = pnModGetVar('ContentExpress', 'default_url');
                pnRedirect( $default_url );
            }


        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function user_print($args)
    {
       /**
        * print item
        * This is a standard function to provide detailed informtion on a single item
        * available from the module.
        * The page is compose of four different major areas:
        * 1) content parents path hyper links to provide quick access to parent content
        * 2) immediate childrens' title hyper links if any
        *    (those WITH menu item reference ONLY)
        * 3) title of the current content
        * 4) the current content including any immediate sub-contents
        *    (immediate children content WITHOUT menu item reference ONLY)
        */
        // Get parameters from whatever input we need.  All arguments to this
        // function should be obtained from pnVarCleanFromInput(), getting them
        // from other places such as the environment is not allowed, as that makes
        // assumptions that will not hold in future versions of PostNuke.
        list($ceid, $objectid) = pnVarCleanFromInput('ceid', 'objectid');

        // User functions of this type can be called by other modules.  If this
        // happens then the calling module will be able to pass in arguments to
        // this function through the $args parameter.  Hence we extract these
        // arguments *after* we have obtained any form-based input through
        // pnVarCleanFromInput().
        extract($args);
    
        // At this stage we check to see if we have been passed $objectid, the
        // generic item identifier.  This could have been passed in by a hook or
        // through some other function calling this as part of a larger module, but
        // if it exists it overrides $tid
        //
        // Note that this module couuld just use $objectid everywhere to avoid all
        // of this munging of variables, but then the resultant code is less
        // descriptive, especially where multiple objects are being used.  The
        // decision of which of these ways to go is up to the module developer
        if (!empty($objectid)) {
            $ceid = $objectid;
        }
    
        // Create output object - this object will store all of our output so that
        // we can return it easily when required
        $output = new pnCEHTML();
        //$output->SetOutputMode(_PNH_RETURNOUTPUT);
        $mytheme = pnUserGetTheme();
    
        // Stylesheet stuff from theme goes here: may need to re-work for supporting
        // other theme engine later on
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text("<link rel=\"StyleSheet\" href=\"themes/$mytheme/style/styleNN.css\" type\"text/css\"/>\n");
        $output->Text("<style type=\"text/css\">");
        $output->Text("@import url(\"themes/$mytheme/style/style.css\"); ");
        $output->Text("</style>\n");
        $output->SetInputMode(_PNH_PARSEINPUT);
    
        // Load API.  All of the actual work for obtaining information on the items
        // is done within the API, so we need to load that in before we can do
        // anything.  If the API fails to load an appropriate error message is
        // posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return $output->GetOutput();
        }
    
        if( $ceid > 0 ) {
            $this->display_content( $output, $ceid, -1, true );
        }
    
        // Return the output that has been generated by this function
        // Assuming the PN core know CE is doing print instead of display, so
        // it will skip the header/footer stuff because we use the PrintPage() function of pnHTML API
        $output->PrintPage();
        return true;
    }

    function user_mailfriend($args)
    {
        //getting the arguments
        list($ceid, $meid, $yourname, $yourmail, $hisname, $hismail) = pnVarCleanFromInput('ceid', 'meid', 'yourname', 'yourmail', 'hisname', 'hismail');
        extract($args);
        //creating an output object
        $output = new pnCEHTML();
        //we need to load the user api, because we want to get the concerning item
        if (!pnModAPILoad('ContentExpress', 'user'))
        {
            pnSessionSetVar('errormsg', _LOADFAILED);
            return $output->GetOutput();
        }
        //ceid has to be set
        if(!isset($ceid))
        {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }
        //The call has to come from the form on the site(for security reasons)
        if (!pnSecConfirmAuthKey())
        {
           $output->Text(_BADAUTHKEY);
           return $output->GetOutput();
        }
        //checking whether the user is logged in. Using this info
        if(pnUserLoggedIn())
        {
            $uid = pnUserGetVar('uid');
            $uname = pnUserGetVar('uname');
        }
        else
        {
            $uid = 1;
            $uname = pnConfigGetVar('anonymous');
        }
        $sitename = pnConfigGetVar('sitename');

        //getting the concerning item
        $item = pnModAPIFunc('ContentExpress',
                             'user',
                             'get_contentitem',
                             array('ceid' => $ceid));

        if ($item == false)
        {
            $output->Text(_MENUCONTENTNOSUCHITEM);
            return $output->GetOutput();
        }

        if (!pnSecAuthAction(0, 'ContentExpress::', '::', ACCESS_READ) || !pnSecAuthAction(0, 'ContentExpress::Content', ":$item[title]:$ceid", ACCESS_READ))
        {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }

        //checking filled in emails
        $valid = pnVarValidate($yourmail, 'email');
        if ($valid == false)
        {
            $output->Text( _MENUCONTENTEMAILWRONG);
            return $output->GetOutput();
        }
        $valid = pnVarValidate($hismail, 'email');
        if ($valid == false)
        {
            $output->Text( _MENUCONTENTEMAILWRONG);
            return $output->GetOutput();
        }
        //convert time
        $formatted_time = ml_ftime(_DATETIMELONG, mktime());

        //Preparing mail
        $newlang = pnSessionGetVar('lang');
        $subject = _MENUCONTENTINTERESTINGITEM." ". $sitename;
        $itemurl = pnModURL( 'ContentExpress', 'user', 'display', array( 'ceid' => $ceid ));
        $signed = pnConfigGetVar('notify_from');
        $message = _MENUCONTENTHELLO." ". $hisname.":\r\n"._MENUCONTENTYOURFRIEND." ". $yourname ." "._MENUCONTENTCONSIDERED."\r\n\n".$item['title']." ("._MENUCONTENTFDATE." ". $item['start_date'].")\n";
        $message .= _MENUCONTENTURL.": " . $itemurl . "\r\n";
        $message .= _MENUCONTENTYOUCANREAD." :".pnGetBaseURL()."\n";
        $message .= "\r\n".$signed;
        //now send the prepared mail
        pnMail($hismail, $subject, $message, "From: \"".$yourname."\" <".$yourmail.">\nX-Mailer: PHP/" . phpversion());
        $newurl = pnModURL('ContentExpress',
                                 'user',
                                 'mailsent',
                                 array('ceid'=>$ceid,
                                       'meid'=>$meid,
                                       'title'=>urlencode($item['title']),
                                       'hisname'=>urlencode($hisname)));
        //$output->Text($newurl);
        //return $output->GetOutput();
        pnRedirect($newurl);
        return true;

    }

    function user_mailsent($args)
    {
        list($ceid,$meid,$title, $hisname) = pnVarCleanFromInput('ceid','meid','title','hisname');
        extract($args);
        $mytheme = pnUserGetTheme();
        $output = new pnCEHTML();
        $title = pnVarPrepForDisplay($title);
        $hisname = pnVarPrepForDisplay($hisname);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text("<font class=\"pn-normal\">"._MENUCONTENTSTORY." <b>".$title."</b> "._MENUCONTENTHASSENT." ".$hisname."... "._MENUCONTENTTHANKS."</font>");
        $output->LineBreak(2);
        $returnto = CommonExpress_display_themeable_anchor($mytheme,pnModURL('ContentExpress','user','display',array('ceid'=>$ceid,'meid'=>$meid)),_MENUCONTENTRETURN,"Return to the article");
        $output->Text($returnto);
        $output->SetInputMode(_PNH_PARSEINPUT);
        return $output->GetOutput();
    }

    function user_sendfriend($args)
    {
        list($ceid, $meid, $objectid) = pnVarCleanFromInput('ceid', 'meid', 'objectid');
        extract($args);
        if (!empty($objectid))
        {
            $ceid = $objectid;
        }

        $output = new pnCEHTML();
        //checking for read access
        if (!pnSecAuthAction(0, 'ContentExpress::Content', '::', ACCESS_READ))
        {
            $output->Text(_MENUCONTENTNOAUTH);
            return $output->GetOutput();
        }
        if(pnUserLoggedIn())
        {
            $uid = pnUserGetVar('uid');
            $uname = pnUserGetVar('uname');
            $uemail = pnUserGetVar('email');
        }
        else
        {
            $uid = 1;
            $uname = pnConfigGetVar('anonymous');
        }
        //outputting title
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Title(_MENUCONTENTTITLESENDFRIEND);
        $output->SetInputMode(_PNH_PARSEINPUT);

        //starting form
        $output->FormStart(pnModURL('ContentExpress', 'user', 'mailfriend'));
        $output->TableStart( "", "", 0, "100%", 0, 0 );
        $output->FormHidden('ceid', $ceid);
        $output->FormHidden('meid', $meid);
        $output->FormHidden('authid', pnSecGenAuthKey());
        //Your name
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSFYOURNAME));
        $row[] = $output->FormText('yourname', $uname, 25, 50 );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        //Your email
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSFYOURMAIL));
        $row[] = $output->FormText('yourmail', $uemail, 25, 50 );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
        //His name
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSFHISNAME));
        $row[] = $output->FormText('hisname', $hisname, 25, 50 );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);
        //His email
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(pnVarPrepForDisplay(_MENUCONTENTSFHISMAIL));
        $row[] = $output->FormText('hismail', $hismail, 25, 50 );
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddrow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        //ending table and form
        $output->TableEnd();
        $output->FormSubmit(_MENUCONTENTSUBMITSENDFRIEND);
        $output->FormEnd();
        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    function display_content( &$output, $ceid, $meid, $print_mode = false )
    {
        // Load API.  Note that this is loading the user API, that is because the
        // user API contains the function to obtain item information which is the
        // first thing that we need to do.  If the API fails to load an appropriate
        // error message is posted and the function returns
        if (!pnModAPILoad('ContentExpress', 'user')) {
            $output->Text(_LOADFAILED);
            return;
        }

        //If the $ceid is two, then we are asked to create an index of all active pages.
        //If this is not the case we'll just display the requested page
        if ($ceid==-2){
            //Getting all the items that we want to include in the index page
            $items = pnModAPIFunc('ContentExpress',
                              'user',
                              'getall_contentitems',
                              array('curr_status' => 2));

            // Since there will be a time when there is nothing in the table, so
            // it won't make sense to create an index here.
            // There might be item in the database, but they would have to be set active to be displayed in the indexpage.
            if ($items == false) {
              $output->Text(_CENOINDEXTOMAKE);
              return $output->GetOutput();
            }
            //Display the top table
            $output->SetInputMode(_PNH_PARSEINPUT);
            $output->TableStart( _CEINDEXTITLE, "", 0, "100%", 0, 0 );
            $output->TableRowStart();
            $output->TableColStart( 1, 'left');
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text("<b><font class=\"pn-normal\">"._CEINDEXINTRO."</font></b>");
            // Built the content tree array
            //Setting starting vars for the items
            $prev_pid = -1;
            $prev_weight_min = 999999999999;
            $prev_cid = -1;
            $contents = array();
            //For each item, we'll make an entry in our array. The $items is already grouped by its
            //parent_id, so the order in which they are processed is OK (see SQL statement in
            //getall_contentitems)
            foreach($items as $item) {
                $id = $item['id'];
                $parent_id = $item['parent_id'];
                $title = $item['title'];
                $weight = $item['weight'];
                $status = $item['status'];
                if( $prev_pid != $parent_id )
                {
                  $prev_pid = $parent_id;
                  $prev_weight_min = 999999999999;
                }
                $contents[(int)$id] = array( 'id'      => (int)$id,
                                             'title'   => $title,
                                             'parent'  => (int)$parent_id,
                                             'times_read' => $item['times_read'],
                                             'show_times_read' => $item['show_times_read'],
                                             'last_updated' => $item['last_updated'],
                                             'show_last_updated' => $item['show_last_updated'],
                                             'author' => $item['author'],
                                             'child'   => array() );
                $prev_cid = (int)$id;
            }
            //updating the childs entries
            foreach( $contents as $id => $contentitem ) {
                $parent_id = $contentitem['parent'];
                if( $parent_id > 0 && !empty( $contents[$parent_id] )) {
                // locates the parent and then updates its child list
                    array_push( $contents[$parent_id]['child'], $id );
                }
            }
            //$contents array is now created. Let's build the tree by calling api_buildindex for each top level article
            foreach ($contents as $id => $contentitem)
            {
                if ($contentitem['parent']==-1){
                    $this->api_buildindex($output, $contents, $contentitem);
                }
            }
            //Display closing table
            $output->TableColEnd();
            $output->TableRowEnd();
            $output->TableEnd();
        }
        else
        {
            //The $ceid was not -2. So the index page was not called. We need to display the
            //corresponding ceid as an article.
            // The API function is called.  The arguments to the function are passed in
            // as their own arguments array
            $item = pnModAPIFunc('ContentExpress',
                                 'user',
                                 'get_contentitem',
                                 array('ceid' => $ceid,
                                       'curr_date' => strftime( "%Y-%m-%d %H:%M:%S", time() ),
                                       'curr_status' => '2' ));
    
            // The return value of the function is checked here, and if the function
            // suceeded then an appropriate message is posted.  Note that if the
            // function did not succeed then the API function should have already
            // posted a failure message so no action is required
            if ($item == false) {
                $output->Text(_MENUCONTENTITEMFAILED);
                return $output->GetOutput();
            }
            //now that we know that there is a content item we should increase its times read field

            $times = pnModAPIFunc('ContentExpress',
                                  'user',
                                  'updateread',
                                  array('ceid' => $ceid,
                                        'currentval' => $item['times_read']));
            //checking whether we could update the times_read field
            if ($times == false) {
                $output->Text(_MENUCONTENTITEMTIMESFAILED);
                //return $output->GetOutput();
            }
            // Add menu to output - it helps if all of the module pages have a standard
            // menu at their head to aid in navigation

            //Add start table for background color
            if ($item['backgroundcolor']){
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("<table width=\"100%\"><tr ><td bgcolor=\"".$item['backgroundcolor']."\">");
                $output->SetInputMode(_PNH_PARSEINPUT);
            }
            $output->Text(pnModFunc('ContentExpress', 'user', 'usermenu', array( 'ceid' => $ceid)));
            $output->SetInputMode(_PNH_VERBATIMINPUT);
    
            // The API function is called.  The arguments to the function are passed in
            // as their own arguments array
            $items = pnModAPIFunc('ContentExpress',
                                  'user',
                                  'getall_subcontentitems',
                                  array('ceid' => $ceid,
                                        'curr_date' => strftime( "%Y-%m-%d %H:%M:%S", time() ),
                                        'curr_status' => '2' ));
    
            $enable_qadmin = pnModGetVar('ContentExpress', 'enable_qadmin');
            $enable_top_print = pnModGetVar('ContentExpress', 'enable_top_print');
            $enable_bottom_print = pnModGetVar('ContentExpress', 'enable_bottom_print');
            $enable_display_navigation = pnModGetVar('ContentExpress', 'enable_display_navigation');
            $enable_top_sendfriend = pnModGetVar('ContentExpress', 'enable_top_sendfriend');
            $enable_bottom_sendfriend = pnModGetVar('ContentExpress', 'enable_bottom_sendfriend');
            $show_last_updated = pnModGetVar('ContentExpress', 'show_last_updated');
            $show_times_read = pnModGetVar('ContentExpress', 'show_times_read');
            $timeformat = pnModGetVar('ContentExpress', 'timeformat');
            $mytheme = pnUserGetTheme();
    
            // It is possible to have not sub-content item for a given content id.
            // Therefore we won't return error message if that's the case
    
            // Display details of the item.  Note the use of pnVarCensor() to remove
            // any words from the name that the administrator has deemed unsuitable for
            // the site.  Also note that a module variable is used here to determine
            // whether not not parts of the item information should be displayed in
            // bold type or not
            $output->TableStart( "", "", 0, "100%", 0, 0 );
            $output->TableRowStart( 'left' );
            if( $item['title_align'] == 1 ) {
                $output->TableColStart( 1, 'left' );
            } else if( $item['title_align'] == 2 ) {
                $output->TableColStart( 1, 'center' );
            } else {
                $output->TableColStart( 1, 'right' );
            }
            list( $title, $text ) = pnModCallHooks( 'item', 'transform', '',
                                                    array( $item['title'],
                                                           $item['text'] ));
    
            $title = pnVarCensor( $title );
            $text = pnVarCensor( $text );
    
            if( $item['enable_title'] > 0 ) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text( "<b><font class=\"pn-content-page-title\">$title</font></b>" );//add table for background color
                $output->SetInputMode(_PNH_PARSEINPUT);
                $output->Linebreak(1);

            }
            $output->TableColEnd();
            $output->TableRowEnd();
            $output->TableRowStart( 'left' );
            $output->TableColStart( 1, 'left' );

            $extra_info = array();

            if ($show_last_updated||(!$show_last_updated && ($item['show_last_updated']))){
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->SetOutputMode(_PNH_RETURNOUTPUT);
                if ($item['last_updated']<>'0000-00-00 00:00:00'){
                   $timef = strftime($timeformat, strtotime($item['last_updated']));
                   $extra_info[] = $output->Text( "<font class=\"pn-content-page-body\">"._CONTENTITEMLASTUPDATED." : $timef</font>");
                }
                $output->SetOutputMode(_PNH_KEEPOUTPUT);
                $output->SetInputMode(_PNH_PARSEINPUT);
            }
            if ($show_times_read||(!$show_times_read && ($item['show_times_read']>0))){
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->SetOutputMode(_PNH_RETURNOUTPUT);
                if (!$times){
                  $extra_info[] = $output->Text( "<font class=\"pn-content-page-body\">(". $item['times_read']." "._CONTENTITEMREAD.")</font>");
                }else
                {
                  $extra_info[] = $output->Text( "<font class=\"pn-content-page-body\">(". $times." "._CONTENTITEMREAD.")</font>");
                }
                $output->SetOutputMode(_PNH_KEEPOUTPUT);
                $output->SetInputMode(_PNH_PARSEINPUT);

            }

            if( count( $extra_info ) > 0 ) {
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text( join( " ", $extra_info ));
                $output->SetInputMode(_PNH_PARSEINPUT);
                $output->Linebreak();
            }

            if(!pnSecAuthAction( 0, "ContentExpress::Content", ":$item[title]:$ceid", ACCESS_READ )) {
                $output->Text(_MENUCONTENTNOAUTH);
                $output->TableColEnd();
                $output->TableRowEnd();
                $output->TableEnd();
                return $output->GetOutput();
            }
    
            $qanchor = array();
    
            if(( pnSecAuthAction( 0, "ContentExpress::Content", ":$item[title]:$ceid", ACCESS_EDIT )) &&
               $enable_qadmin && !$print_mode ) {
                $edit = CommonExpress_display_themeable_anchor( $mytheme,
                                                          pnModURL( 'ContentExpress', 'admin', 'editcontent',
                                                                    array( 'ceid' => $ceid,
                                                                           'meid' => $meid )),
                                                          _MENUCONTENTEDITCONTENT, "edit" );
                $qanchor[] = $edit;
                if( pnSecAuthAction( 0, "ContentExpress::Content", ":$item[title]:$ceid", ACCESS_DELETE )) {
                    $delete = CommonExpress_display_themeable_anchor( $mytheme,
                                                                pnModURL( 'ContentExpress', 'admin', 'delcontent',
                                                                          array( 'ceid' => $ceid,
                                                                                 'meid' => $meid )),
                                                                _MENUCONTENTDELCONTENT, "delete" );
                    $qanchor[] = $delete;
                }
            }
            if((( $item['top_print'] && !$enable_top_print ) || $enable_top_print ) && !$print_mode ) {
                $print = CommonExpress_display_themeable_anchor( $mytheme,
                                                           pnModURL( 'ContentExpress', 'user', 'print',
                                                                     array( 'ceid' => $ceid )),
                                                           _MENUCONTENTPRINT, "print" );
                $qanchor[] = $print;
            }
            if((( $item['top_sendfriend'] && !$enable_top_sendfriend ) || $enable_top_sendfriend ) && !$print_mode ) {
                $sendlink = CommonExpress_display_themeable_anchor( $mytheme,
                                                           pnModURL( 'ContentExpress', 'user', 'sendfriend',
                                                                     array( 'ceid' => $ceid )),
                                                           _MENUCONTENTSENDFRIEND, "email" );
                $qanchor[] = $sendlink;
            }
            if( count( $qanchor ) > 0 ) {
                $output->Text("[");
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text( join( " | ", $qanchor ));
                $output->SetInputMode(_PNH_PARSEINPUT);
                $output->Text("]");
                $output->Linebreak(2);
            }
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            if( strlen( $item['media_url'] ) > 0 ) {
                // bug fix from ekkehard. Many thanks!!
                if( $item['layout_id'] == 1 || $item['layout_id'] == 3 ) {
                    $media_pos = "left";
                } else if( $item['layout_id'] == 2 || $item['layout_id'] == 4 ) {
                    $media_pos = "right";
                }
                if( ereg( "flash", $item['media_type'] )) {
                    $media_tag = "<object codebase=\"modules/ContentExpress/".$item['media_url']."\" align=\"$media_pos\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\"><param name=movie value=\"modules/ContentExpress/".$item['media_url']."\"><param name=quality value=high><embed src=\"modules/ContentExpress/".$item['media_url']."\" quality=high pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\" align=\"$media_pos\"></embed></object>";
                }
                else if( ereg( "image", $item['media_type'] )) {
                    if( $item['media_width'] > 0 && $item['media_height'] > 0 ) {
                        $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$item['media_url']."\" width=\"".$item['media_width']."\" height=\"".$item['media_height']."\">";
                    }
                    else {
                        $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$item['media_url']."\">";
                    }
                } else {
                    $media_tag = "<a href=\"modules/ContentExpress/".$item['media_url']."\"><img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/pnimages/download.gif\"></a>";
                }
                if( $item['layout_id'] == 1 || $item['layout_id'] == 2 ) {
                    $output->Text( $media_tag );
                // bug fix from ekkehard. Many thanks!!
                } else if( $item['layout_id'] == 5 ) {
                    $output->Text( "<center>".$media_tag."</center>" );
                }
                $output->Text( "<font class=\"pn-content-page-body\">$text</font>" );
                if( $item['layout_id'] == 3 || $item['layout_id'] == 4 ) {
                    $output->Text( $media_tag );
                // bug fix from ekkehard. Many thanks!!
                } else if( $item['layout_id'] == 6 ) {
                    $output->Text( "<center>".$media_tag."</center>" );
                }
            }
            else {
                $output->Text( "<font class=\"pn-content-page-body\">$text</font>" );
            }
            $output->SetInputMode(_PNH_PARSEINPUT);
            $output->TableColEnd();
            $output->TableRowEnd();
    
            //If the display_navigation and the navigation in the article is not set, we'll display the full article
            //with its subcontents. This will also so happen for the print mode. If not, we'll display the aricle
            //but not its subcontent and navigation links to view the subcontent.
            if (($enable_display_navigation==0 && $item['navigation']==0) || $print_mode == true) {
                //Checking whether the article has subcontent items
                if( $items != false ) {
                    //Displaying each subcontent
                    foreach( $items as $sitem ) {
                        $output->TableRowStart( 'left' );
                        $output->TableColStart( 1, 'left' );
                        $output->Linebreak(2);
                        list( $stitle, $stext ) = pnModCallHooks( 'item', 'transform', '',
                                                                  array( $sitem['title'],
                                                                         $sitem['text'] ));
                        $stitle = pnVarCensor( $stitle );
                        $stext = pnVarCensor( $stext );
                        $sqanchor = array();
    
                        if( $sitem['enable_title'] > 0 ) {
                            $output->SetInputMode(_PNH_VERBATIMINPUT);
                            $output->Text( "<b><font class=\"pn-pagetitle\">$stitle</font></b>" );
                            $output->SetInputMode(_PNH_PARSEINPUT);
                            $output->Linebreak(1);
                        }
                        if( pnSecAuthAction( 0, "ContentExpress::Content", ":$sitem[title]:$sitem[id]", ACCESS_EDIT ) &&
                            $enable_qadmin &&
                            !$print_mode ) {
                            $edit = CommonExpress_display_themeable_anchor( $mytheme,
                                                                  pnModURL( 'ContentExpress', 'admin', 'editcontent',
                                                                            array( 'ceid' => $sitem['id'],
                                                                                   'meid' => $meid )),
                                                                  _MENUCONTENTEDITCONTENT, "edit" );
                            $sqanchor[] = $edit;
                            if( pnSecAuthAction( 0, "ContentExpress::Content", ":$sitem[title]:$sitem[id]", ACCESS_DELETE )) {
                                $delete = CommonExpress_display_themeable_anchor( $mytheme,
                                                                        pnModURL( 'ContentExpress', 'admin', 'delcontent',
                                                                                  array( 'ceid' => $sitem['id'],
                                                                                         'meid' => $meid )),
                                                                        _MENUCONTENTDELCONTENT, "delete" );
                                $sqanchor[] = $delete;
                            }
                        }
                        if( count( $sqanchor ) > 0 ) {
                            $output->Text( "[" );
                            $output->SetInputMode(_PNH_VERBATIMINPUT);
                            $output->Text( join( " | ", $sqanchor ));
                            $output->SetInputMode(_PNH_PARSEINPUT);
                            $output->Text( "]" );
                            $output->Linebreak(1);
                        }
                        $output->SetInputMode(_PNH_VERBATIMINPUT);
                        if( strlen($sitem['media_url']) > 0 ) {
                            // bug fix from ekkehard. Many thanks!!
                            if( $sitem['layout_id'] == 1 || $sitem['layout_id'] == 3 ) {
                                $media_pos = "left";
                            } else if( $sitem['layout_id'] == 2 || $sitem['layout_id'] == 4 ) {
                                $media_pos = "right";
                            }
                            if( ereg( "flash", $sitem['media_type'] )) {
                                $media_tag = "<object codebase=\"modules/ContentExpress/".$sitem['media_url']."\" align=\"$media_pos\" width=\"".$sitem['media_width']."\" height=\"".$sitem['media_height']."\"><param name=movie value=\"modules/ContentExpress/".$sitem['media_url']."\"><param name=quality value=high><embed src=\"modules/ContentExpress/".$sitem['media_url']."\" quality=high pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"".$sitem['media_width']."\" height=\"".$sitem['media_height']."\" align=\"$media_pos\"></embed></object>";
                            }
                            else if( ereg( "image", $sitem['media_type'] )) {
                                if( $sitem['media_width'] > 0 && $sitem['media_height'] > 0 ) {
                                    $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$sitem['media_url']."\" width=\"".$sitem['media_width']."\" height=\"".$sitem['media_height']."\">";
                                }
                                else {
                                    $media_tag = "<img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/".$sitem['media_url']."\">";
                                }
                            }
                            else {
                                $media_tag = "<a href=\"modules/ContentExpress/".$sitem['media_url']."\"><img align=\"$media_pos\" border=\"0\" alt=\"\" src=\"modules/ContentExpress/pnimages/download.gif\"></a>";
                            }
                            if( $sitem['layout_id'] == 1 || $sitem['layout_id'] == 2 ) {
                                $output->Text( $media_tag );
                            // bug fix from ekkehard. Many thanks!!
                            } else if( $sitem['layout_id'] == 5 ) {
                                $output->Text( "<center>".$media_tag."</center>" );
                            }
                            $output->Text( "<font class=\"pn-content-page-body\">$stext</font>" );
                            if( $sitem['layout_id'] == 3 || $sitem['layout_id'] == 4 ) {
                                $output->Text( $media_tag );
                            // bug fix from ekkehard. Many thanks!!
                            } else if( $sitem['layout_id'] == 6 ) {
                                $output->Text( "<center>".$media_tag."</center>" );
                            }
                        }
                        else {
                            $output->Text( "<font class=\"pn-content-page-body\">$stext</font>" );
                        }
                        $output->SetInputMode(_PNH_PARSEINPUT);
                        $output->TableColEnd();
                        $output->TableRowEnd();
                    }
    
                }
    
            }
            else
            {
                //Either the article has navigation enable or the global navigation option is set.
                //Now checking whether the article has subcontent items.
                if ($items != false) {
                //Show navigation instead of each subitem
                // => Show index of subitems
                    $output->SetInputMode(_PNH_VERBATIMINPUT);
                    $output->TableRowStart( 'left' );
                    $output->TableColStart( 1, 'left' );
                    $output->Text( _CEOTHERTOPICS );
                    $output->LineBreak(1);
                    //Output a list of all the subcontent items
                    foreach( $items as $sitem ) {
                        $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                               array( 'ceid' => $sitem['id'],
                                                                                      'meid' => $meid ) ),$sitem['title'],"Other Topic" ));
                        $output->LineBreak(1);
                    }
                    $output->LineBreak(1);
                    $output->SetInputMode(_PNH_PARSEINPUT);
                    $output->TableColEnd();
                    $output->TableRowEnd();
               }
               if ($item['parent_id']<>-1){
               //getting a list of all the children of its parent
                   $parentitems = pnModAPIFunc('ContentExpress',
                                               'user',
                                               'getall_subcontentitems',
                                               array('ceid' => $item['parent_id'],
                                                     'curr_date' => strftime( "%Y-%m-%d %H:%M:%S", time() ),
                                                     'curr_status' => '2' ));
                   //Unless there is an error in the database, $parentitems should contain at least one item,being the article itself
                   //just checking anyway
                   if ($parentitems != false)
                   {
                       $output->TableRowStart( 'left' );
                       $output->TableColStart( 1, 'left' );
                       //We need to have the id of the first, last previous and next article in order to display the links to them
                       $totalitems = count($parentitems);
                       $last = end($parentitems);
                       $first =reset($parentitems);
    		   //Since the key of the received array are not sequented, we'll make it, without losing any needed information
    		   //The key is always the same as the id field of the object array. This part of the code can be written better later.
    		   $i=0;
    		   foreach (array_keys($parentitems) as $key) {
    		      $newparentitems[$i] = $parentitems[$key];
    		      $i++;
    		   }
    		   //Now we have an array with sequented keys
                       foreach ($newparentitems as $key => $value){
                           if ($newparentitems[$key]['id'] == $ceid){
                               $previous = $newparentitems[(int)$key-1];
                               $next = $newparentitems[(int)$key+1];
                           }
                       }
                       //Display the navigation links
                       $output->SetInputMode(_PNH_VERBATIMINPUT);
                       $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                           array( 'ceid' => $first['id'],
                                                                                       'meid' => $meid ) ),"["._CEFIRST."]","First article" ));
                       $output->Text("&nbsp;&nbsp;");
                       if (!empty($previous)){
                           $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                             array( 'ceid' => $previous['id'],
                                                                                    'meid' => $meid ) ),"["._CEPREVIOUS."]","Previous article" ));
                           $output->Text("&nbsp;&nbsp;");
                       }
                       $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                            array( 'ceid' => $item['parent_id'],
                                                                                       'meid' => $meid ) ),"["._CEPARENT."]","Parent Article" ));
                       $output->Text("&nbsp;&nbsp;");
                       if(!empty($next)){
                           $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                                  array( 'ceid' => $next['id'],
                                                                                       'meid' => $meid ) ),"["._CENEXT."]","Next article" ));
    
                           $output->Text("&nbsp;&nbsp;");
                       }
    
                       $output->Text(CommonExpress_display_themeable_anchor( $mytheme,pnModURL( 'ContentExpress', 'user', 'display',
                                                                             array( 'ceid' => $last['id'],
                                                                                       'meid' => $meid ) ),"["._CELAST."]","Last article" ));
                       $output->SetInputMode(_PNH_PARSEINPUT);
                       $output->TableColEnd();
                       $output->TableRowEnd();
                    }
                }
            }
            $qanchor = array();
            if(((( $item['bottom_print'] && !$enable_bottom_print ) || $enable_bottom_print )||
               (($item['bottom_sendfriend'] && !$enable_bottom_sendfriend)|| $enable_bottom_sendfriend )) &&
               !$print_mode ) {
                if(( $item['bottom_print'] && !$enable_bottom_print ) || $enable_bottom_print )
                {
                    $print = CommonExpress_display_themeable_anchor( $mytheme,
                                                           pnModURL( 'ContentExpress', 'user', 'print',
                                                                     array( 'ceid' => $ceid )),
                                                           _MENUCONTENTPRINT, "print" );
                    $qanchor[] = $print;
                }
                if(($item['bottom_sendfriend'] && !$enable_bottom_sendfriend)|| $enable_bottom_sendfriend )
                {
                    $send = CommonExpress_display_themeable_anchor( $mytheme,
                                                           pnModURL( 'ContentExpress', 'user', 'sendfriend',
                                                                     array( 'ceid' => $ceid )),
                                                           _MENUCONTENTSENDFRIEND, "email" );
                    $qanchor[] = $send;
                }
            }
            if( count( $qanchor ) > 0 ) {
                $output->TableRowStart('left');
                $output->TableColStart(1, 'left');
                $output->Text("[");
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text( join( " | ", $qanchor ));
                $output->SetInputMode(_PNH_PARSEINPUT);
                $output->Text("]");
                $output->TableColEnd();
                $output->TableRowEnd();
            }

            // Let any hooks know that we are displaying an item.  As this is a display
            // hook we're passing a URL as the extra info, which is the URL that any
            // hooks will show after they have finished their own work.  It is normal
            // for that URL to bring the user back to this function
            $output->TableEnd();
            if ($item['backgroundcolor']){
                $output->SetInputMode(_PNH_VERBATIMINPUT);
                $output->Text("</td></tr></table>");//table of background color
                $output->SetInputMode(_PNH_PARSEINPUT);
            }
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $output->Text(pnModCallHooks('item',
                                         'display',
                                         $ceid,
                                         pnModURL('ContentExpress',
                                                  'user',
                                                  'display',
                                                  array('ceid' => $ceid,
                                                        'meid' => $meid ))));
            $output->SetInputMode(_PNH_PARSEINPUT);
        }
    }

    function contentblock_init()
    {
        // Security
        pnSecAddSchema('ContentExpress::Contentblock', 'Block title::Block ID' );
    }

    function contentblock_info()
    {
        // Values
        return array('text_type' => 'CEContent',
                     'module' => 'ContentExpress',
                     'text_type_long' => 'CE Content Item Block',
                     'allow_multiple' => true,
                     'form_content' => true,
                     'form_refresh' => true,
                     'show_preview' => true);
    }

    function contentblock_modify( $blockinfo )
    {
        // Create output object
        $output = new pnHTML();

        // Get current content
        $vars = pnBlockVarsFromContent($blockinfo['content']);

        // Content item listing
        $contents = array();
        $listing = array();
        CommonExpress_build_item_list($listing, "contentitems" );
        foreach( $listing as $id => $content ) {
            $contents[] = array( 'id' => $id, 'selected' => 0, 'name' => $content );
        }

        // Which content to display
        $row = array();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $row[] = $output->Text(_CECONTENTITEM);
        $row[] = $output->FormSelectMultiple('ceid', $contents, 0, 1, $vars['ceid'] );
        $output->SetOutputMode(_PNH_KEEPOUTPUT);

        // Add row
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->TableAddRow($row, 'left');
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Return output
        return $output->GetOutput();
    }

    function contentblock_update( $blockinfo )
    {
        $vars['ceid'] = pnVarCleanFromInput( 'ceid' );

        $blockinfo['content'] = pnBlockVarsToContent($vars);

        return $blockinfo;
    }

    function contentblock_display( $blockinfo )
    {
        // Security check
        if (!pnSecAuthAction(0, "ContentExpress::Contentblock", "$blockinfo[title]::$blockinfo[bid]", ACCESS_READ)) {
            return;
        }

        $output = new pnHTML();

        // Get variables from content block
        $vars = pnBlockVarsFromContent($blockinfo['content']);
    
        if (!isset($vars['ceid']) || $vars['ceid'] < 0 ) {
            $output->Text(_CENOCONTENT);
        }else{
            $this->display_content( $output, $vars['ceid'], -1 );
        }

        $blockinfo['content'] = $output->GetOutput();

        return themesideblock($blockinfo);
    }
}
?>
